#include "stdafx.h"
#include "CSoundManager.h"
#include "FDKError.h"
#include "CSound.h"
#include "CSoundStream.h"
#include "Debug.h"

namespace FDK {
	namespace Sound {

extern BYTE g_SampleMP3[16301];

// static Ȃ
LPDIRECTSOUND8	CSoundManager::pDS = NULL;
double CSoundManager::dbMP3Đxms = 0.0;
int	CSoundManager::nCX^X = 0;

CSoundManager::CSoundManager()
{
	if( this->nCX^X++ == 0 )
	{
		this->pDS = NULL;
		dbMP3Đxms = 0.0;
	}
	this->soundList = this->soundListLast = NULL;
}
CSoundManager::~CSoundManager()
{
	if( --this->nCX^X == 0 )
		SAFE_RELEASE( this->pDS );
}
HRESULT CSoundManager::Init( HWND hWnd, DWORD dwCoopLevel )
{
    HRESULT	hr;

	// pȂɏI
	if( this->soundList )
		Term();

	// ȉA߂ẴCX^X̏ꍇɎsB
	if( this->pDS == NULL )
	{
		// DirectSound ̍쐬
		if( FAILED( hr = DirectSoundCreate8( NULL, &this->pDS, NULL ) ) )
			return hr;

		// x̐ݒ
		if( FAILED( hr = this->pDS->SetCooperativeLevel( hWnd, dwCoopLevel ) ) )
		{
			SAFE_RELEASE( this->pDS );
		    return hr;
		}

		// xԂ̎Zo
		this->tMP3xԂvZL();
	}
    return S_OK;
}

void	CSoundManager::Term()
{
	SoundList *cell, *next;
	cell = this->soundList;
	while( cell != NULL )
	{
		next = cell->next;
		if( cell->pSound ) cell->pSound->Term();
		REMOVELIST( this->soundList, this->soundListLast, cell );
		SAFE_DELETE( cell->pSound );
		SAFE_DELETE( cell );
		cell = next;
	}
}
//
CSound* CSoundManager::pLbVȂTEh𐶐ĕԂ( LPCTSTR filename )
{
	HRESULT hr;

	CSound* cell = new CSound();
	cell->Init();
	if( FAILED( hr = cell->CreateFromFile( this->pDS, filename ) ) )
	{
		cell->Term();
		SAFE_DELETE( cell );
		return NULL;			// 쐬Ɏs
	}
	return cell;
}
//
CSoundStream* CSoundManager::pLbVȂXg[TEh𐶐ĕԂ( LPCTSTR filename )
{
	HRESULT hr;

	CSoundStream* cell = new CSoundStream();
	cell->Init();
	if( FAILED( hr = cell->CreateFromFile( this->pDS, filename ) ) )
	{
		cell->Term();
		SAFE_DELETE( cell );
		return NULL;			// 쐬Ɏs
	}

	//  CSoundStream CX^XXgɉB
	this->setSoundStream.insert( cell );

	return cell;
}
void	CSoundManager::tLbVȂXg[TEh폜( CSoundStream* pSoundStream )
{
	if( ! pSoundStream )
		return;

	if( pSoundStream->bĐ )
		pSoundStream->Stop();

	//  CSoundStream CX^XXg폜B
	this->setSoundStream.erase( pSoundStream );
	SAFE_DELETE( pSoundStream );
}
void	CSoundManager::tXg[TEh̍Đ()
{
	CSoundStream* pss;
	
	this->setSoundStream.resetList();
	while( ( pss = this->setSoundStream.getNext() ) != NULL )
		pss->StreamWork();
}
//
void	CSoundManager::tgptONAZ폜()
{
	// ͍폜Ał̓tONÂ݁B
	SoundList* cell = this->soundList, *next;
	while( cell != NULL )
	{
		next = cell->next;

		if( cell->bł )
		{
			cell->pSound->Term();
			REMOVELIST( this->soundList, this->soundListLast, cell );
			SAFE_DELETE( cell->pSound );
			SAFE_DELETE( cell );
		}
		else
			cell->bgp = false;
	
		cell = next;
	}
}

CSound* CSoundManager::pLbVΉTEh쐬ĕԂ( LPCTSTR filename )
{
	// t@C̍ŏIXV̎擾G
	// fileInfo  w肳ꂽt@C̍ŏIXV
	WIN32_FILE_ATTRIBUTE_DATA fileInfo;
	if( ! GetFileAttributesEx( filename, GetFileExInfoStandard, &fileInfo) )
		return NULL;		// t@C̏擾Ɏs

	// LbVT
	SoundList* cell;
	for( cell = this->soundList; cell != NULL; cell = cell->next )
	{
		if( lstrcmp( filename, cell->strt@C ) == 0 
			&& ( fileInfo.ftLastWriteTime.dwLowDateTime  == cell->ftŏIXV.dwLowDateTime )
			&& ( fileInfo.ftLastWriteTime.dwHighDateTime == cell->ftŏIXV.dwHighDateTime ) )
		{
			// ̂̂
			if( ! cell->bgp )
			{
				// ŏ̂P͌ł̂܂܎g
				cell->bgp = true;
				cell->bł = false;
				return cell->pSound;
			}
			else
			{
				// Qڈȍ~͕𐶐
				SoundList* ncell = NULL;
				ncell = new SoundList();
				ncell->bgp = true;
				ncell->bł = true;
				ncell->ftŏIXV = cell->ftŏIXV;
				lstrcpyn( ncell->strt@C, cell->strt@C, _MAX_PATH );
				ncell->prev = ncell->next = NULL;
				ncell->pSound = new CSound();
				ncell->pSound->Init();
				if( FAILED( ncell->pSound->DuplicateFromSound( this->pDS, cell->pSound ) ) )
				{
					ncell->pSound->Term();
					SAFE_DELETE( ncell->pSound );
					SAFE_DELETE( ncell );
					return NULL;	// LbV̕Ɏs
				}
				APPENDLIST( this->soundList, this->soundListLast, ncell );
				return ncell->pSound;
			}
		}
	}

	// LbVɂȂ̂ŐVK
	HRESULT hr;
	cell = new SoundList();
	cell->pSound = new CSound();
	cell->pSound->Init();
	if( FAILED( hr = cell->pSound->CreateFromFile( this->pDS, filename ) ) )
	{
		SAFE_DELETE( cell->pSound );
		SAFE_DELETE( cell );
		return NULL;		// TEhobt@̐VK쐬Ɏs
	}
	cell->bgp = true;
	cell->bł = false;
	cell->ftŏIXV = fileInfo.ftLastWriteTime;
	lstrcpyn( cell->strt@C, filename, _MAX_PATH );
	cell->prev = cell->next = NULL;
	APPENDLIST( this->soundList, this->soundListLast, cell );

	return cell->pSound;
}

void	CSoundManager::tgpTEh폜()
{
	SoundList* cell = this->soundList, *next;
	while( cell != NULL )
	{
		next = cell->next;
		if( ! cell->bgp )
		{
			cell->pSound->Term();
			REMOVELIST( this->soundList, this->soundListLast, cell );
			SAFE_DELETE( cell->pSound );
			SAFE_DELETE( cell );
		}
		cell = next;
	}
}

//
HRESULT CSoundManager::SetPrimaryBufferFormat( DWORD dwPrimaryChannels, DWORD dwPrimaryFreq, DWORD dwPrimaryBitRate )
{
    HRESULT hr;
    LPDIRECTSOUNDBUFFER pDSBPrimary = NULL;

	if( this->pDS == NULL )
		return FDKERR_DirectSoundNULL;

	// vC}obt@̎擾
    DSBUFFERDESC dsbd;
    ZeroMemory( &dsbd, sizeof(DSBUFFERDESC) );
	dsbd.dwSize        = sizeof(DSBUFFERDESC);
	dsbd.dwFlags       = DSBCAPS_PRIMARYBUFFER;
	dsbd.dwBufferBytes = 0;
    dsbd.lpwfxFormat   = NULL;
	if( FAILED( hr = this->pDS->CreateSoundBuffer( &dsbd, &pDSBPrimary, NULL ) ) )
		return hr;	// vC}obt@̎擾Ɏs

	// tH[}bg̐ݒ
    WAVEFORMATEX wfx;
    ZeroMemory( &wfx, sizeof(WAVEFORMATEX) ); 
	wfx.wFormatTag      = (WORD)  WAVE_FORMAT_PCM; 
    wfx.nChannels       = (WORD)  dwPrimaryChannels; 
    wfx.nSamplesPerSec  = (DWORD) dwPrimaryFreq; 
    wfx.wBitsPerSample  = (WORD)  dwPrimaryBitRate; 
	wfx.nBlockAlign     = (WORD)  (wfx.wBitsPerSample / 8 * wfx.nChannels);
    wfx.nAvgBytesPerSec = (DWORD) (wfx.nSamplesPerSec * wfx.nBlockAlign);
    if( FAILED( hr = pDSBPrimary->SetFormat(&wfx) ) )
        return hr;		// vC}obt@̃tH[}bg̐ݒɎs

	// vC}obt@̉
	SAFE_RELEASE( pDSBPrimary );
    return S_OK;
}

HRESULT CSoundManager::GetPrimaryBufferFormat( DWORD* pdwPrimaryChannels, DWORD* pdwPrimaryFreq, DWORD* pdwPrimaryBitRate )
{
    HRESULT hr;
    LPDIRECTSOUNDBUFFER pDSBPrimary = NULL;

	if( this->pDS == NULL )
		return FDKERR_DirectSoundNULL;

	// vC}obt@̎擾
    DSBUFFERDESC dsbd;
    ZeroMemory( &dsbd, sizeof(DSBUFFERDESC) );
	dsbd.dwSize        = sizeof(DSBUFFERDESC);
	dsbd.dwFlags       = DSBCAPS_PRIMARYBUFFER;
	dsbd.dwBufferBytes = 0;
    dsbd.lpwfxFormat   = NULL;
	if( FAILED( hr = this->pDS->CreateSoundBuffer( &dsbd, &pDSBPrimary, NULL ) ) )
		return hr;	// vC}obt@̎擾Ɏs

	// tH[}bg̎擾
    WAVEFORMATEX wfx;
    ZeroMemory( &wfx, sizeof(WAVEFORMATEX) ); 
	if( FAILED( hr = pDSBPrimary->GetFormat( &wfx, sizeof(WAVEFORMATEX), NULL ) ) )
		return hr;

	*pdwPrimaryChannels = (DWORD) wfx.nChannels;
	*pdwPrimaryFreq = (DWORD) wfx.nSamplesPerSec;
	*pdwPrimaryBitRate = (DWORD) wfx.wBitsPerSample;

	// vC}obt@̉
	SAFE_RELEASE( pDSBPrimary );
    return S_OK;
}
//
void	CSoundManager::tMP3xԂvZL()
{
	HRESULT hr;

	// g_SampleMP3[] TEhobt@쐬
	CSound sd;
	sd.Init();
	if( FAILED( hr = sd.CreateFromMemory( this->pDS, g_SampleMP3, 16301 ) ) )
	{
		sd.Term();
		return;		// SampleMP3  CSound 𐶐邱ƂɎs
	}

	// WAVEFORMATEX ̎擾
	DWORD dwSize;
	sd.GetDirectSoundBuffer()->GetFormat( NULL, 0, &dwSize );
	WAVEFORMATEX* pWF = (LPWAVEFORMATEX) malloc( dwSize );
	sd.GetDirectSoundBuffer()->GetFormat( pWF, dwSize, NULL );

	// TEhobt@ Lock
	LPVOID bufp1 = NULL, bufp2 = NULL;
	DWORD dwSize1 = 0, dwSize2 = 0;
	if( FAILED( hr = sd.GetDirectSoundBuffer()->Lock( 0, 0, &bufp1, &dwSize1, &bufp2, &dwSize2, DSBLOCK_ENTIREBUFFER) ) )
	{
		SAFE_FREE( pWF );
		sd.Term();
		return;		// TEhobt@ Lock Ɏs
	}

	// 
	BYTE *p = (LPBYTE) bufp1;
	int bn = 0;
	for( WORD i = 0; i < dwSize1; i++ )
	{
		DWORD data = 0;
		for( int j = 0; j < pWF->nBlockAlign; j++ )
		{
			data = (data << 8) | ((DWORD)(*p));
			p++;
		}
		// d1=Ad2=EB
		// ܂ SampleMP3  ch2, 16bit ƕĂ͂邪Ô߃tH[}bgĕB
		SHORT d1, d2;
		if( pWF->nChannels == 1 )
		{
			if (pWF->wBitsPerSample == 16) {		// ch1, 16bit
				d1 = 0;
				d2 = (SHORT) (((data & 0x00FF) << 8) | ((data & 0xFF00) >> 8));
			} else {								// ch1, 8 bit
				d1 = 0;
				d2 = (SHORT) (data & 0x00FF);
			}
		}
		else
		{
			if (pWF->wBitsPerSample == 16) {		// ch2. 16bit
				d1 = (SHORT)(((data & 0x00FF0000) >> 8) | ((data & 0xFF000000) >> 24));
				d2 = (SHORT)(((data & 0x000000FF) << 8) | ((data & 0x0000FF00) >>  8));
			} else {								// ch2. 8bit
				d1 = (SHORT) ((data & 0xFF00) >> 8);
				d2 = (SHORT) (data & 0x00FF);
			}
		}
			
		// 
		if (d1 > 20000 || d1 < -20000 || d2 > 20000 || d2 < -20000)
			break;
		bn ++;
	}
		
	// vZ
	dbMP3Đxms = bn * 1000.0 / pWF->nSamplesPerSec;

	sd.GetDirectSoundBuffer()->Unlock( bufp1, dwSize1, bufp2, dwSize2 );
	SAFE_FREE( pWF );
	sd.Term();
}
static BYTE g_SampleMP3[16301] = {
// xԎZopMP3f[^
0xff,0xfb,0x92,0x00,0x00,0x00,0x02,0xde,0x05,0x5b,0x85,0x30,0x00,0x00,0x5d,0x00,
0x9b,0x70,0xa6,0x00,0x00,0x0b,0x8e,0x41,0x7c,0x19,0x11,0x00,0x09,0x77,0xc8,0x2f,
0x83,0x22,0x20,0x01,0x00,0xe0,0x4c,0x1b,0x88,0xe4,0xf3,0x33,0x33,0xf5,0xee,0x0d,
0x07,0xc1,0xf0,0x7c,0xa1,0xf0,0x7c,0x1f,0x13,0x3c,0x1f,0x07,0xcb,0xbc,0x1f,0x13,
0xda,0x5f,0xe8,0xc1,0x02,0x90,0x7c,0x10,0x51,0xf0,0x7c,0x1c,0x87,0xc1,0xf1,0x3c,
0x1f,0x07,0xcb,0xc1,0xf1,0x3c,0xe0,0x3f,0x86,0x15,0xff,0xff,0xfb,0x84,0x13,0xe0,
0xe1,0x48,0x3e,0x0f,0xa9,0xe0,0xff,0xfd,0xe0,0xe1,0x48,0x3e,0x0f,0x94,0x0f,0x83,
0xe0,0xfa,0xc1,0xf0,0x7c,0xbc,0x1f,0x07,0xe7,0x04,0x3f,0xff,0xff,0xff,0xff,0xfc,
0x00,0xc0,0x98,0x1f,0x11,0xc9,0xe6,0x66,0x6b,0xdf,0x28,0x1f,0x07,0xc1,0xf0,0x72,
0x1f,0x07,0xc1,0xf2,0x87,0xc1,0xf0,0x7c,0xbb,0xc1,0xf0,0x7f,0xff,0xc1,0xf0,0x7d,
0x6f,0x07,0xc1,0xfb,0xc1,0xf1,0x3d,0xe0,0xfa,0xff,0xff,0xff,0xff,0xff,0x9f,0x07,
0xd7,0x0f,0x83,0xeb,0x83,0xe0,0xfc,0x30,0x09,0x89,0xe1,0x80,0x40,0xbe,0x08,0x0a,
0xe7,0x01,0x01,0x3c,0x30,0x08,0x02,0x70,0x40,0x10,0x10,0x41,0x00,0x40,0xa4,0x10,
0x04,0x3f,0xc3,0x05,0x2e,0x04,0x04,0x1f,0xff,0xff,0xff,0xff,0xfc,0x11,0x21,0xde,
0x0a,0xd1,0x34,0x05,0x59,0x64,0xbe,0x5c,0x1c,0x25,0x01,0x70,0x94,0x94,0xc5,0x22,
0x92,0x8c,0x5e,0x0c,0x48,0x21,0x4b,0x38,0x91,0xcc,0x71,0x41,0x95,0x08,0xc6,0x3a,
0x94,0xc8,0x86,0x39,0xdc,0x84,0x77,0x7a,0x96,0x65,0x64,0x3b,0xb9,0x12,0xd9,0x11,
0x18,0xba,0xdd,0xd7,0x2d,0x99,0xa8,0x8a,0xf2,0xa7,0xff,0x5b,0x3b,0xa2,0xad,0x1f,
0x44,0xd3,0xff,0xff,0xfe,0xbf,0xff,0xff,0xff,0xff,0xff,0xff,0xbd,0x25,0xaa,0xd9,
0xbf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x82,0x24,0x3b,0xc1,0x5a,0x26,0x80,
0xbb,0x29,0x97,0xcb,0x83,0x84,0xb0,0x33,0x25,0x25,0x4a,0x45,0x24,0x8c,0x4c,0x81,
0xca,0x08,0x53,0x39,0xc4,0x8e,0x28,0x77,0x31,0xc8,0x46,0x31,0xd5,0x4d,0x43,0x1c,
0xe7,0x21,0x2b,0x24,0xa5,0x45,0x2b,0x3b,0xae,0xec,0xc5,0x44,0x6b,0x15,0x2b,0xb5,
0x69,0x62,0xbd,0x15,0xdf,0x4d,0x98,0xeb,0x6d,0x7f,0xf3,0x68,0xad,0xff,0xfd,0x13,
0x66,0xeb,0xfd,0x3f,0xae,0xd5,0xff,0xff,0xff,0xff,0xff,0xb5,0x6f,0xa7,0xfa,0x66,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x1a,0x55,0xb9,0x27,0xb3,0x6b,0xff,
0xff,0xff,0xff,0xfb,0x92,0x00,0x05,0x80,0x02,0xbb,0x90,0x66,0x6e,0x08,0x20,0x02,
0x58,0x32,0x0c,0xcd,0xc1,0x04,0x00,0x4c,0xc6,0x41,0x93,0xb8,0x70,0x80,0x09,0x69,
0xc8,0x32,0xf7,0x0a,0x10,0x01,0xff,0xff,0xf0,0x03,0x07,0x20,0x22,0xad,0xee,0xeb,
0x69,0x14,0x28,0x8c,0xc8,0x51,0x02,0xd2,0x61,0x23,0x02,0x09,0x18,0x27,0x0c,0x44,
0xe9,0x88,0xda,0x1c,0x8d,0x9a,0x0c,0x89,0xa0,0x94,0x2c,0x13,0x22,0x67,0x39,0x9a,
0x6c,0x24,0x42,0x4d,0x80,0xcf,0xb3,0x9c,0xaa,0xe7,0x9d,0x26,0x5f,0xe7,0xfe,0x5f,
0xda,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xe0,0x02,0x03,0x4a,0xcd,0x24,0xb6,0xed,0xbf,0xdf,0xff,0xff,0xff,0xfe,
0x20,0xc1,0xc8,0x08,0xab,0x7b,0xba,0xb1,0x51,0x8e,0x68,0x86,0x64,0x28,0x80,0x9d,
0x33,0x23,0x46,0x64,0x30,0x4e,0x14,0x29,0x30,0x91,0x18,0x93,0x60,0x31,0x50,0x50,
0x13,0x41,0x23,0x32,0xa6,0x52,0x62,0xc6,0xd3,0x11,0x90,0x08,0xed,0x33,0x45,0xcb,
0xb8,0x48,0xeb,0x2e,0xbd,0x7f,0xc8,0xcb,0xff,0xbf,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x00,0x00,0x20,0xc9,0x4d,
0xb7,0x2c,0xb6,0xed,0xae,0xfb,0xef,0xff,0x11,0x49,0x89,0x48,0x12,0x96,0xbb,0x1e,
0xc7,0xa6,0x8a,0xa0,0x4d,0x81,0x3b,0x71,0x85,0xbb,0x24,0x6a,0xcc,0x8a,0x04,0x30,
0x8c,0x18,0x2d,0x8b,0xb2,0x45,0x50,0x14,0x85,0x91,0x98,0xd3,0xb2,0x49,0xd0,0xfa,
0x48,0x66,0x65,0x77,0x64,0x86,0x31,0xc6,0x6a,0xc0,0x93,0x72,0x28,0x23,0x36,0x4c,
0x91,0x41,0x95,0x51,0x76,0x2c,0xb9,0x98,0xee,0xca,0x57,0x76,0x57,0x9d,0xdb,0x9d,
0x69,0x21,0x99,0x82,0x9b,0x91,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xf8,0x00,0x00,0x10,0x89,0x5a,0xed,0x97,0x5d,0xbf,0xff,0xff,0xff,0xff,0x88,0x9c,
0x3c,0x80,0xad,0x76,0x3b,0x1f,0xa2,0xc0,0x16,0xd2,0x19,0x8e,0x31,0xa7,0x26,0x04,
0x73,0x66,0x45,0x51,0x9c,0x0c,0x60,0xb6,0xc8,0x80,0xc1,0x47,0x4a,0x44,0x56,0x2d,
0x9b,0x4c,0x15,0x49,0x91,0x17,0x3d,0x1b,0x38,0x09,0x5b,0x8c,0xf6,0xe9,0x33,0x32,
0xa4,0xfa,0xfc,0xcd,0x6b,0x2b,0x72,0x2b,0x6e,0x57,0xff,0xfd,0x65,0xfe,0xcb,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x4d,0x00,0x00,0x00,0x01,
0x09,0x48,0xd0,0x67,0xeb,0x36,0x27,0x33,0x27,0x9f,0x1a,0x0a,0xdd,0xb3,0x7f,0x1a,
0x4f,0xbb,0x7f,0x16,0xff,0xfb,0x92,0x00,0x0c,0x80,0x03,0x6c,0x68,0xdf,0x57,0x60,
0x60,0x0a,0x64,0x85,0x3b,0x90,0xec,0x94,0x00,0x0b,0x48,0x65,0x76,0x47,0xa4,0xa7,
0x01,0x73,0x0f,0xee,0x85,0x85,0x95,0x28,0x51,0x73,0x2e,0x74,0xf0,0x9d,0x6e,0x97,
0x7c,0x6c,0x17,0xb7,0x0f,0x6f,0x2e,0xf9,0x70,0xf6,0xf3,0xe1,0xe5,0xdf,0x53,0x37,
0x90,0x8d,0xf8,0xd9,0x19,0x25,0xa7,0xbf,0x0b,0x32,0xe7,0x9e,0x9e,0x7d,0x2c,0x2e,
0x43,0x50,0x59,0x8f,0x82,0x38,0xda,0x8d,0x41,0xe4,0x35,0x05,0xc6,0xd9,0xe0,0x23,
0x21,0x14,0x1e,0xa4,0x6c,0xf2,0x11,0xbc,0x8c,0xa4,0xeb,0x2d,0x1c,0xc3,0xc8,0xa6,
0xe9,0xb5,0xc7,0x40,0x94,0xc7,0x70,0x69,0xae,0xa3,0x38,0x2b,0xf7,0x68,0x16,0x5c,
0xa9,0x0e,0xcf,0x66,0x4b,0xfe,0xcc,0x19,0x35,0x9c,0x66,0x8f,0x18,0x73,0x72,0x59,
0xe8,0x1d,0x86,0x0d,0x43,0x0e,0x40,0x12,0x34,0x7c,0x38,0xea,0x25,0x8e,0x89,0xd0,
0x56,0x20,0xea,0x6c,0x7c,0x65,0x07,0x44,0xda,0x5a,0x0f,0x8c,0xc7,0xc6,0x65,0xab,
0x2a,0xdc,0x7b,0xa5,0x88,0x3d,0x8a,0x4b,0x5c,0x38,0x83,0x1f,0x51,0xc7,0x28,0xba,
0x19,0x41,0x33,0x8e,0x55,0xf5,0xa1,0xae,0xa5,0x8f,0xad,0x0e,0xa9,0x2c,0x7d,0x0d,
0x75,0x49,0x7c,0x62,0x1a,0xed,0x86,0xea,0xf4,0xb3,0xd1,0xfb,0x3d,0xd5,0xa3,0xa5,
0x8e,0x00,0x12,0xa1,0x92,0x08,0x69,0x4a,0x22,0xd3,0x9b,0x5b,0x38,0x10,0xe0,0xe6,
0xd1,0x0f,0x3a,0x7f,0x9e,0xf4,0x0f,0x0b,0x67,0x11,0xa8,0xfb,0xb4,0x74,0x6b,0x46,
0x51,0xae,0xd1,0x49,0x17,0xb9,0x42,0xa7,0xdc,0xb4,0xb6,0xb5,0x92,0x74,0xb1,0x03,
0x8e,0x52,0x0e,0xbd,0x6a,0x6b,0xe5,0x5a,0xda,0x92,0x16,0x4a,0x96,0x71,0xcc,0x01,
0xb1,0x8b,0x2e,0x81,0xb1,0xed,0x3e,0xf6,0xa1,0xa9,0x51,0x44,0x0e,0x8c,0x69,0xc7,
0x31,0x22,0xc8,0x59,0x78,0xd6,0x8f,0x63,0xf4,0x6a,0xfb,0x40,0x75,0x51,0x2a,0x92,
0xaa,0xda,0x6a,0xdd,0x6a,0x3d,0x92,0x3d,0x90,0x2c,0x74,0x14,0xe6,0x26,0x79,0x6f,
0x04,0x7c,0xae,0xad,0x5d,0x55,0xe2,0xcd,0x0c,0x8d,0x68,0x85,0x1a,0x66,0x8e,0xa3,
0xc4,0xe9,0xab,0xc7,0xc8,0x9f,0x7a,0x08,0x9e,0xa8,0xa3,0x9d,0x2a,0xc7,0x4b,0xa4,
0xed,0x73,0xef,0xa1,0x95,0x14,0x40,0xc8,0xc6,0x9f,0x72,0xd2,0xd4,0xac,0xbb,0x1c,
0xd2,0xcc,0x65,0x48,0x1b,0x55,0xaf,0x62,0x5b,0xad,0x23,0xaa,0xb0,0xc0,0xb2,0x3a,
0xef,0xfa,0x91,0xec,0xfd,0x7f,0x6f,0xee,0x20,0x00,0x00,0x00,0x05,0xc9,0x80,0x47,
0x23,0xc1,0x16,0x18,0x91,0xdd,0xff,0xfb,0x92,0x00,0x07,0x00,0x03,0x43,0x67,0xde,
0xca,0x42,0x1b,0x7a,0x5b,0x6b,0xcc,0x6d,0x44,0x43,0x6f,0x4c,0x15,0xa1,0x7a,0xe9,
0x08,0x6d,0xc9,0x76,0x8e,0xee,0x85,0x85,0x95,0x28,0x90,0x8c,0x5e,0x3d,0x2b,0x54,
0x78,0x15,0x45,0x42,0xbc,0xd5,0x78,0x5a,0x16,0x0d,0xe1,0x69,0x83,0xa2,0xc1,0x69,
0x47,0xa6,0x4a,0x3c,0x9d,0x2e,0x9e,0x9d,0x2d,0xfc,0xba,0x59,0xf0,0x88,0xcb,0x3f,
0x32,0x3f,0x1c,0xd4,0xf6,0xe9,0x9a,0xf9,0x74,0xcd,0x6c,0x22,0x0b,0x62,0xd0,0x45,
0x82,0xb0,0xb0,0x53,0x92,0x78,0x29,0x64,0x07,0x34,0x94,0xbb,0x74,0x4a,0x44,0xf6,
0x11,0x3a,0x90,0xb7,0x86,0x4f,0x90,0xe6,0x46,0x63,0x9e,0x39,0x96,0x63,0x1d,0x33,
0x55,0x83,0x12,0x3f,0xf3,0x2a,0x99,0x34,0xa0,0x5b,0x4e,0x5d,0xcb,0x80,0xad,0x24,
0x08,0xb1,0x2d,0x1a,0x59,0xe9,0x93,0x52,0xab,0xc3,0x55,0xeb,0xa5,0x75,0xf5,0xd7,
0xd7,0x3d,0x1e,0x4d,0xe9,0xb6,0xf6,0xf2,0xff,0x2f,0x2f,0xf2,0xe1,0x6d,0xe5,0xcf,
0x3e,0x9f,0x25,0xfb,0xf2,0x5f,0xb6,0x3f,0x4b,0x7b,0x0c,0xde,0xee,0x70,0xcd,0x3c,
0xcc,0x8c,0xc8,0xb1,0xcc,0xbc,0x62,0x63,0x31,0x36,0x11,0x34,0x65,0x58,0x84,0xd2,
0x96,0x0a,0x59,0x2f,0x82,0x97,0x80,0xe9,0x8a,0xd0,0x9e,0x54,0x30,0x93,0xca,0x5f,
0x40,0x00,0x01,0x2a,0x4a,0x27,0xa0,0x07,0x72,0x78,0x6b,0x8d,0xe8,0xb8,0x67,0x4a,
0xb2,0x3d,0xa5,0x4a,0x8e,0xa1,0x6a,0x49,0x1e,0x26,0xaf,0x09,0x8f,0x57,0xa5,0x1e,
0xdb,0xd3,0x5d,0xe9,0xad,0x1e,0xfe,0x5d,0xf7,0xf2,0xd7,0xef,0x7c,0xbc,0xbb,0xe5,
0xe7,0xaf,0x7e,0x79,0x74,0xf9,0xe7,0xe7,0xb7,0x33,0x09,0x4c,0x79,0x08,0xc1,0xec,
0x70,0xd3,0x5c,0x16,0x6f,0x31,0xad,0x23,0xbd,0x2c,0xae,0xa6,0x0f,0x24,0xb8,0xd5,
0x4d,0x62,0xc3,0x52,0xb4,0xd0,0x16,0x69,0x71,0xd1,0xb6,0xa5,0x1f,0x1e,0x42,0x30,
0x40,0x3a,0xf2,0x01,0x8e,0x5c,0xf5,0xa9,0xc7,0xb2,0xdf,0x8f,0xc5,0x71,0x4d,0x6c,
0x68,0xcc,0x4c,0xe4,0x81,0xd5,0x2c,0xe9,0x7c,0xd7,0x57,0x88,0x61,0xb1,0xaf,0x19,
0x41,0xf2,0xbc,0xd1,0x99,0xf1,0xf1,0x92,0xe4,0x4f,0x39,0x49,0x6b,0x94,0x93,0xf5,
0x15,0x4b,0xea,0x26,0xfa,0x9a,0x75,0xf2,0x8d,0x7b,0x0a,0x34,0xed,0x08,0x6d,0x68,
0x0b,0xd6,0x59,0x0f,0x8e,0x20,0x3e,0x39,0x87,0x5f,0x4b,0x1e,0xd4,0xb3,0x4a,0x58,
0x95,0xa4,0x20,0x95,0xa7,0xae,0xef,0xed,0xd2,0xdf,0xe9,0xd5,0xfb,0xef,0x80,0x00,
0x02,0x54,0xac,0xe6,0xf3,0x53,0xb1,0xb7,0xff,0xfb,0x92,0x00,0x05,0x00,0x02,0xd1,
0x2a,0x5d,0xb3,0x05,0x12,0x60,0x66,0x0d,0x1b,0xfa,0x44,0x43,0x6f,0x4b,0xe0,0x8d,
0x74,0xac,0xa4,0xa9,0x41,0x67,0x8e,0xee,0xd9,0x84,0x89,0x28,0xb7,0x4d,0x7b,0xe4,
0xb3,0xf0,0x14,0x7a,0x00,0xf5,0x0d,0x84,0x30,0xc8,0x56,0x1b,0x1b,0x9d,0x94,0xd2,
0x3c,0x2d,0x07,0x82,0xc4,0x51,0xa4,0xab,0xd7,0x35,0x1e,0x5a,0x3e,0xd4,0xda,0x98,
0xf4,0xb5,0xea,0x10,0x9d,0x72,0xd0,0xc7,0x56,0x4d,0xf5,0xa0,0x22,0x60,0x58,0xb3,
0xaa,0x43,0x5f,0x5a,0x18,0xe1,0x88,0x0b,0x1b,0x15,0x2c,0xd7,0xac,0xbb,0x1c,0xc1,
0x88,0x17,0x37,0x8f,0x40,0xb2,0x5a,0xea,0x90,0xdf,0xff,0x77,0xca,0x00,0x00,0x00,
0x40,0x94,0xa0,0xa7,0x80,0x1a,0x33,0x17,0xe3,0xcc,0x8b,0x4e,0x9b,0xcc,0x5d,0x45,
0xfa,0x8f,0x09,0x8d,0x05,0xbd,0x77,0xaa,0x6f,0x5d,0xe9,0xb5,0x36,0xa9,0xa7,0x69,
0xa8,0xf0,0xbe,0x7d,0x2d,0x38,0x5a,0x7b,0x74,0xb6,0xe9,0xeb,0xef,0xd3,0xd3,0xc6,
0x80,0xb2,0x6b,0x48,0xdb,0xa9,0xd3,0x20,0x73,0x1e,0x82,0xc8,0x68,0x0b,0x22,0xb7,
0xa6,0x47,0x2e,0x64,0x0e,0x63,0x90,0x32,0xd3,0x85,0x13,0x73,0xb4,0x8d,0xad,0x32,
0x0b,0x31,0x65,0x4f,0x4d,0x06,0x80,0x8c,0x85,0x5a,0x46,0xd6,0xa2,0x56,0x27,0x86,
0x6a,0x0a,0x90,0x00,0x1d,0xfd,0x1b,0x12,0x42,0x93,0xf1,0x5e,0xb0,0xde,0xcc,0xb9,
0xf2,0x07,0x25,0x62,0xaf,0x62,0xf6,0x47,0x69,0x47,0xac,0xee,0x63,0xa7,0x91,0x17,
0x86,0x46,0x3c,0x4b,0x1f,0x13,0x2a,0x2d,0x1a,0x74,0x54,0xab,0xc7,0x51,0xe6,0xc7,
0xba,0x92,0x07,0xe8,0x26,0xc7,0xad,0x0d,0x72,0xd2,0xca,0x90,0x4d,0x95,0x21,0xae,
0x59,0xb6,0x54,0x68,0x9a,0xd6,0x00,0x43,0x6b,0x41,0xda,0x8d,0xb6,0xb3,0x04,0xb5,
0xa0,0xed,0x49,0x3d,0x17,0x31,0xb0,0x7a,0x1f,0x52,0x75,0xa3,0xfa,0xba,0xfa,0xbf,
0xf7,0x10,0x00,0x00,0x2a,0x8c,0x8f,0xd2,0x42,0xaa,0x71,0x5e,0xb5,0x9e,0xd5,0x7c,
0xf4,0x1c,0x6a,0xc8,0xbd,0x9f,0xb4,0x7d,0x29,0xf5,0xb3,0xbb,0xa7,0x90,0xb8,0xd4,
0x78,0x2a,0x8f,0x3b,0x4f,0x46,0xbd,0x5a,0x0e,0x55,0xae,0x7a,0xd8,0x7d,0xd2,0xcc,
0x7c,0xab,0x5d,0x43,0x4f,0xe8,0x63,0xe9,0x63,0x96,0x60,0x98,0xbc,0x0e,0x40,0x55,
0xea,0x36,0x76,0xb3,0x04,0xd6,0x28,0x07,0x41,0xea,0x92,0x76,0x2e,0x61,0xd1,0x60,
0x3a,0x1c,0xc5,0x12,0x7a,0x45,0x50,0xe4,0x0b,0xaf,0xef,0x80,0x00,0x3a,0x1f,0x03,
0x5f,0x4c,0x94,0xb0,0xbe,0x32,0xaf,0xa8,0xf7,0x50,0xff,0xfb,0x92,0x00,0x07,0x80,
0x02,0xed,0x1c,0xdd,0x2b,0x09,0x2a,0x50,0x68,0x6c,0x9b,0xda,0x60,0xa3,0x6e,0x4c,
0x69,0x93,0x7f,0x47,0x88,0x6d,0xe9,0x6b,0x0e,0xee,0xc9,0x84,0x89,0x28,0x89,0x8e,
0x11,0xcb,0x17,0xb3,0x1b,0x43,0xfd,0x77,0x74,0x7d,0x3c,0x85,0x51,0x63,0x1a,0x23,
0x51,0xf2,0xbc,0x7e,0xd6,0xc7,0x1c,0x59,0x72,0x2f,0x7a,0x10,0x79,0xca,0x2a,0xca,
0xd6,0xd7,0xd4,0x45,0xce,0xa5,0xef,0x5a,0x19,0x50,0xd6,0x9c,0xac,0x90,0xc7,0xd0,
0xf7,0x34,0xab,0x6b,0x1c,0xc6,0x54,0x83,0xef,0x6a,0x5c,0xea,0x19,0x8d,0x6b,0x50,
0xa4,0x9c,0x73,0x51,0x7f,0xd5,0xd7,0xe8,0xbb,0xeb,0xea,0xfd,0xfe,0x60,0x00,0x00,
0x00,0x1a,0x96,0x8e,0x88,0x0b,0x5c,0x98,0xcb,0xcf,0x83,0xed,0xf7,0x24,0x5f,0x35,
0xcf,0x9d,0xa8,0xf8,0xec,0x36,0x76,0x8b,0xd5,0xa2,0x14,0x3c,0x66,0xb5,0xd7,0x35,
0x1a,0x5d,0xb7,0xbe,0xf3,0xf9,0x73,0xe7,0x3e,0xf1,0x70,0x66,0x4d,0xc1,0xf6,0x2c,
0x6b,0x9e,0x5e,0x7d,0x2d,0xfa,0x5c,0xff,0x99,0x83,0xe9,0x90,0x5a,0x4d,0x21,0x6b,
0x31,0xa9,0x3e,0x3c,0x83,0x9b,0xc5,0x10,0xa0,0xb2,0x08,0x40,0xb3,0x07,0x59,0x5c,
0x1b,0x93,0x48,0x3a,0x32,0x63,0x5c,0x7a,0x57,0x1d,0x9d,0x09,0xda,0x91,0x04,0xda,
0x90,0x2c,0xaa,0xf5,0x23,0x1a,0x80,0x40,0x00,0x00,0x29,0x46,0xf0,0x29,0x39,0x9d,
0xa6,0xbe,0x8b,0xaf,0x5e,0x85,0xdb,0xf5,0xe3,0xe3,0xc5,0x54,0xd0,0x7a,0x55,0xa7,
0xc7,0xa3,0x4d,0x5d,0x32,0x6d,0x7d,0xa9,0xa5,0x32,0x79,0x79,0xeb,0xcf,0x9e,0x7c,
0x3c,0xbc,0xfb,0xf7,0x87,0xbe,0x63,0xe4,0x64,0xd6,0x9e,0x0f,0x8f,0x69,0x18,0xfd,
0x1c,0x9a,0xd6,0xa0,0xfd,0xf5,0x18,0xcc,0x8c,0x55,0x85,0x82,0xb4,0xad,0xc8,0x6f,
0x23,0x6d,0x16,0x02,0xf4,0xb4,0xc8,0x8c,0x86,0x90,0x88,0x1c,0x96,0x02,0x72,0x16,
0x59,0x92,0xc4,0x5a,0x0e,0x1e,0xa5,0x51,0x80,0x00,0xaa,0x03,0x0d,0x54,0xfb,0x3d,
0x73,0xf8,0xdc,0x7e,0x49,0x72,0xc4,0x6e,0x90,0xff,0xe7,0xfa,0x2e,0x9b,0x56,0x77,
0xf5,0x3d,0xba,0xec,0xe2,0xa0,0x9a,0x0a,0xad,0x23,0xc6,0xa3,0x4d,0x46,0x82,0x94,
0x22,0xca,0x88,0xbd,0xcb,0x28,0xd7,0xac,0xaa,0x1f,0x5b,0x5b,0x5a,0x5c,0xf5,0x2d,
0xae,0x50,0x15,0x27,0x18,0xa6,0x05,0x8c,0x0c,0x41,0xc3,0x42,0xca,0x14,0x72,0xcd,
0x20,0xe5,0x6d,0x08,0x98,0x1e,0x96,0xb8,0x5d,0x6d,0x7c,0xca,0x4f,0xb5,0x68,0x0b,
0x1b,0xa3,0xee,0x40,0x00,0x08,0x54,0xdc,0x41,0xe0,0x8a,0xc7,0xff,0xfb,0x92,0x00,
0x04,0x80,0x02,0xb5,0x10,0x5d,0xb3,0x09,0x11,0xc2,0x6a,0x0c,0xbc,0x0d,0x4c,0x43,
0x6f,0x4c,0x3c,0x91,0x72,0x0c,0x2c,0xa9,0x41,0x8a,0x32,0x6f,0xa8,0xf1,0x09,0xb9,
0x58,0xfe,0x9b,0xb7,0x9c,0x08,0x72,0x17,0xd9,0x4f,0x47,0xec,0x87,0xd8,0x89,0x47,
0x85,0xa8,0xdc,0x46,0x3f,0x98,0xcd,0x7e,0x63,0x31,0xae,0xfa,0x8d,0x77,0x7a,0x25,
0xfd,0xcb,0x47,0xff,0x75,0x77,0x77,0x57,0x77,0xf2,0xee,0xfe,0x6d,0xdf,0xdd,0xd9,
0x5a,0xd7,0xb3,0xee,0x86,0xcc,0xfb,0x12,0x33,0xbe,0x4c,0x4f,0x74,0x6e,0xeb,0x50,
0xbd,0xdd,0x66,0xec,0xd7,0xf7,0x4c,0x6b,0xba,0xbe,0xab,0xd5,0xdf,0xfb,0x84,0x00,
0x00,0x00,0x00,0x4a,0x32,0x51,0x36,0x80,0x5c,0x07,0x68,0xf9,0x1b,0xf2,0x3a,0x70,
0xa9,0x31,0x7a,0x18,0xf0,0xb5,0x6a,0xbd,0x76,0x97,0x26,0xd5,0xab,0x53,0x5d,0xab,
0x47,0xa3,0x57,0x79,0xb8,0xfe,0x7c,0xe1,0xed,0xd4,0xf3,0xdb,0x85,0xa9,0xf3,0x87,
0xaf,0x4b,0xcf,0x5e,0x96,0xbf,0x3c,0x49,0x00,0xe1,0xc6,0x66,0x54,0x06,0xb4,0x4e,
0x03,0x42,0x1a,0x9a,0xa0,0x52,0x04,0x3d,0x15,0x52,0xab,0xb5,0x02,0x30,0x46,0xac,
0xaf,0x1a,0x36,0x2b,0x09,0xb1,0x33,0xb1,0xc6,0x31,0x31,0xe3,0x23,0x1a,0x90,0x32,
0x62,0x8e,0xcb,0x57,0x12,0x06,0x48,0xaa,0x7f,0x18,0x93,0x51,0xe0,0x56,0xad,0xa8,
0xdf,0xf5,0xa8,0xe2,0xc3,0xd0,0x3a,0x75,0x08,0xf9,0x13,0x82,0x17,0x28,0xbc,0xdb,
0x93,0x28,0x56,0x0b,0x1a,0xd0,0xf5,0x47,0x46,0xe3,0xe3,0x5a,0x25,0x41,0xf1,0xb8,
0xfa,0x3c,0xb8,0xf8,0xda,0x88,0x9d,0xa9,0x0c,0x72,0x90,0xc7,0x56,0x49,0xd5,0xa5,
0xb5,0x13,0x6b,0xea,0x3e,0xf5,0x97,0x46,0x92,0x07,0x3b,0xaa,0x46,0xa4,0x35,0xfb,
0x1f,0x5a,0x75,0xa5,0xae,0xa5,0xae,0xaa,0xfa,0x90,0xcb,0x10,0xc7,0x47,0x46,0x56,
0x9a,0x1a,0x96,0xbd,0xaf,0x8f,0xaa,0xb4,0xd0,0xc7,0x00,0x00,0x00,0x00,0x13,0x2d,
0x2a,0x80,0x49,0x60,0x3b,0x0f,0xbe,0x93,0xfd,0xa3,0xb6,0x6f,0x0f,0x71,0xe0,0xa8,
0x35,0x1e,0x6c,0x68,0x2d,0xaa,0xd4,0xda,0xbb,0xd5,0xa9,0xbd,0x77,0xde,0xbb,0xd7,
0x5d,0xeb,0xb5,0x1e,0xbb,0x53,0x6a,0x3d,0x36,0xa6,0xfb,0x53,0x6a,0xb3,0x19,0x15,
0x98,0x1e,0x3a,0x2b,0x31,0x96,0x3b,0x83,0xb3,0xa2,0x3b,0x85,0x58,0xee,0x0e,0xe2,
0x55,0x1d,0xc1,0xac,0x62,0x82,0xb9,0x55,0x19,0x81,0x24,0x65,0x04,0xec,0x64,0x8c,
0xc0,0x91,0xc7,0x45,0x66,0x32,0x46,0x30,0x35,0xa5,0x5a,0x17,0x60,0x00,0xff,0xfb,
0x92,0x00,0x01,0x00,0x02,0xf2,0x64,0xdf,0xba,0x22,0x1b,0x7a,0x5f,0xc4,0x9b,0x90,
0x65,0x85,0x4a,0x0c,0x2d,0x8f,0x87,0xa9,0x04,0x6d,0xe9,0x5e,0xae,0xf1,0xb5,0x00,
0x89,0xbd,0x00,0x08,0x4a,0x1f,0x06,0x52,0xb0,0xb4,0x0f,0x4c,0x46,0x4e,0x9a,0xcc,
0x9a,0x5b,0xa0,0xf0,0xf4,0x58,0x26,0x97,0x69,0xe8,0x78,0x3c,0xbb,0x49,0x92,0xba,
0xef,0xbd,0xa9,0xa7,0x4f,0xcb,0x3e,0x1f,0x38,0xbc,0x2c,0xf8,0x5d,0xfb,0xcf,0x5f,
0x2e,0x96,0x9d,0xfb,0xe5,0xe6,0x49,0x69,0x50,0x5e,0xde,0x64,0x9c,0x38,0x0b,0xda,
0xc2,0x33,0xcc,0x78,0x0b,0xec,0x84,0x6d,0x90,0xdd,0x23,0xb2,0x1a,0xa9,0x90,0xc7,
0x49,0x12,0xd9,0x41,0xe4,0x2b,0xcc,0x92,0xaa,0x40,0x54,0xe1,0xf5,0x55,0xe4,0x45,
0x2d,0x42,0x94,0x51,0x8f,0x71,0x7c,0x7c,0x17,0x15,0xc1,0xe9,0xcb,0x8c,0xbe,0x04,
0x1d,0x33,0xe8,0x1b,0xc2,0x97,0x79,0xec,0xe2,0x28,0xbb,0x20,0xba,0x85,0xb4,0x46,
0x83,0xa5,0x76,0x14,0x8d,0x68,0xda,0x9a,0x57,0x61,0xd4,0x79,0x2a,0x8a,0x35,0x8f,
0x56,0x50,0xfb,0xa5,0x98,0xd5,0x2c,0x8b,0xdc,0xa2,0x0c,0xa9,0x37,0xca,0xb0,0xe5,
0x49,0x7d,0x76,0x3a,0x8e,0xb6,0xbb,0x43,0x6a,0xdd,0x4b,0x35,0x25,0xfd,0x95,0x22,
0xfa,0x9b,0xbd,0x0e,0xae,0x2e,0xea,0x36,0xae,0xfb,0xba,0xb3,0x7b,0x2c,0xa7,0xa6,
0x00,0x20,0x12,0x52,0x4a,0x5c,0x18,0xe8,0x1a,0x42,0x23,0xf0,0xd2,0x44,0x87,0xcb,
0x26,0xf3,0x3d,0x09,0x38,0x37,0xab,0xd4,0x3b,0x9b,0x8a,0x4a,0x59,0xcf,0x29,0xe5,
0x9c,0x9c,0xfc,0xb9,0xe5,0xe7,0x9f,0x9f,0x96,0x5e,0x5d,0xf3,0xe1,0x6d,0xc2,0xee,
0x77,0xbf,0x3c,0xf8,0x64,0xf6,0x93,0x3a,0xe2,0x24,0x3c,0xe6,0x3d,0x35,0xc6,0x90,
0x62,0x58,0xe2,0x9c,0x31,0x9b,0x50,0x44,0x40,0xf4,0xa4,0x0f,0x30,0x5a,0x6c,0x12,
0x13,0xda,0x44,0xf6,0x8d,0x11,0xb1,0xa6,0x3d,0x3b,0x8d,0x44,0x91,0x56,0xb4,0x59,
0x79,0x40,0x04,0x14,0x93,0x4e,0x5d,0xc3,0x51,0x03,0x24,0x47,0xe1,0xe9,0x63,0xae,
0x59,0x2b,0xd7,0xb6,0xeb,0x7e,0xf5,0x0e,0xe7,0x94,0xb2,0xf3,0xcb,0x52,0xde,0xef,
0x6f,0x6d,0xe9,0xbd,0x35,0xae,0xba,0x51,0xdc,0x94,0x7a,0xb4,0xfb,0x5b,0x7d,0xe6,
0x54,0x69,0xb2,0xd5,0xdd,0x2b,0x70,0x56,0x3c,0x13,0xb0,0x75,0x51,0x91,0x0b,0x10,
0x91,0xd5,0xd6,0x3a,0xa3,0x4a,0x91,0x98,0xb7,0x33,0xa3,0x38,0x29,0x2c,0x0e,0xf9,
0xcc,0x53,0x4d,0x0a,0x27,0xb6,0x1b,0x20,0x00,0x00,0x54,0xdd,0x01,0xe1,0x9c,0x56,
0xff,0xfb,0x92,0x00,0x04,0x80,0x02,0xc1,0x18,0xdd,0xb3,0x0c,0x29,0xc0,0x69,0x6d,
0x1b,0xea,0x60,0x43,0x6f,0x4b,0x19,0x09,0x78,0x4c,0x14,0x4b,0x89,0x97,0x2f,0xef,
0x69,0x81,0x09,0xb9,0x68,0x13,0xae,0x07,0xb2,0x37,0xf2,0xab,0xf8,0x87,0x28,0x48,
0xe5,0x57,0x68,0xb4,0x2d,0xa2,0x94,0x1d,0x12,0xa9,0x2c,0xf2,0xd3,0x3e,0x3d,0xeb,
0x4b,0x0f,0x28,0xb1,0x16,0x54,0x83,0xf5,0xa5,0xcf,0x52,0xc9,0x3a,0xa2,0x0f,0xae,
0x79,0xfb,0x5d,0x28,0xc0,0x8d,0x24,0x45,0x9e,0xb4,0xb6,0xa3,0x04,0x9e,0x2e,0x03,
0x43,0xa2,0xe4,0xde,0x68,0x51,0x67,0x8c,0xb5,0x4c,0x72,0x0b,0xb4,0x7a,0x64,0x85,
0x5f,0x43,0x3f,0xa6,0x00,0x00,0x00,0x00,0x04,0xa3,0xd0,0x11,0x5b,0x0d,0x8a,0x04,
0xec,0x31,0xfb,0x93,0xf6,0x67,0xba,0xaf,0x41,0xe2,0xaa,0x68,0x36,0x8d,0x46,0x82,
0xa8,0x8a,0xbc,0xb4,0x7b,0xb4,0xd5,0xcf,0xb5,0x34,0xde,0x5e,0x5e,0x79,0xf4,0xfb,
0xe5,0xc2,0xe7,0x4f,0x2f,0x5e,0x7b,0xf9,0xf7,0xd3,0xc8,0x9b,0xb3,0x86,0x62,0x6c,
0x2c,0x3d,0xc7,0x3a,0x78,0x39,0x46,0x23,0x22,0x68,0x08,0xcd,0x38,0x32,0x82,0x7d,
0xfc,0x73,0x0b,0x6c,0x4a,0x44,0xd2,0x95,0x08,0xc6,0x32,0x86,0x46,0x07,0x60,0xe6,
0xae,0x6d,0x01,0x91,0x1e,0xa2,0x94,0x14,0x34,0x23,0x18,0x81,0xd0,0x06,0x3f,0x7d,
0x83,0xbf,0x2e,0x6c,0x8f,0x66,0xdd,0xbf,0xa9,0x0a,0xf8,0xe3,0xa8,0x1a,0x30,0x7a,
0x87,0x6a,0x29,0x11,0x79,0xe8,0x3a,0x27,0x41,0x58,0xc7,0x9a,0x8f,0x2e,0x4a,0xbc,
0x9b,0x57,0x2d,0x1e,0x6a,0x1e,0x8f,0x25,0x5e,0x98,0xd0,0x6d,0x2d,0x73,0x33,0x9d,
0x11,0xa9,0xbd,0x36,0xaf,0xfb,0x39,0xd2,0x33,0x82,0xc7,0x82,0xfe,0xee,0x6a,0x95,
0xb3,0x7a,0xe6,0xee,0xef,0x69,0xdb,0xa9,0x5b,0x37,0x66,0x77,0x5a,0x9f,0x67,0x6e,
0xad,0x5d,0x7b,0x33,0xba,0x42,0x00,0x00,0x00,0x10,0x4c,0xb6,0x1a,0x12,0xbc,0xf3,
0x64,0x68,0x1b,0x7f,0xfe,0xa4,0x8b,0xe6,0x3b,0xba,0x68,0x21,0xd4,0x2d,0x44,0x41,
0xbc,0x5d,0x1a,0x7a,0x16,0x8f,0x35,0x1e,0xbb,0x57,0x25,0x1a,0x76,0x96,0x8f,0x4d,
0xe9,0xb5,0x7e,0xbb,0x57,0x7a,0x6f,0x4d,0xab,0xf5,0xda,0xbb,0x52,0xe3,0xa2,0x6c,
0xe5,0x45,0xbb,0x02,0x48,0xc7,0x07,0x61,0x94,0x13,0xb8,0xa4,0x31,0xd1,0xdd,0x88,
0xaa,0x39,0x01,0x2b,0x0c,0x70,0x6c,0xc2,0x54,0xb4,0x33,0x39,0xd1,0x19,0x82,0x2a,
0x8e,0xc0,0x96,0x27,0x30,0xd3,0x58,0x90,0xba,0x94,0xa1,0xf5,0x00,0x00,0x00,0x01,
0x0d,0xd0,0xff,0xfb,0x92,0x00,0x03,0x80,0x03,0x1e,0x68,0xe0,0x52,0x22,0x1b,0x7a,
0x5d,0xe3,0xbb,0xa5,0x61,0x22,0x4a,0x0b,0x4c,0x75,0x74,0x2c,0xa4,0x49,0x41,0x8c,
0x34,0x6f,0xe9,0x21,0x0d,0xbd,0xee,0x80,0xf8,0x74,0x75,0x0d,0xe9,0x04,0x9c,0x54,
0xc9,0xa7,0xa0,0x9e,0x1b,0x1a,0x8f,0x4a,0x35,0xb7,0xa6,0x5d,0xe9,0x97,0x79,0xe9,
0xae,0xf4,0xd7,0xcf,0xbf,0x7a,0x79,0xf9,0xf7,0xdb,0xa7,0xdf,0x6f,0x2d,0xfb,0xf3,
0xcf,0xbf,0x3c,0xba,0x46,0x0b,0x41,0xa1,0xad,0x43,0x04,0x44,0x26,0xd1,0x98,0x16,
0x4b,0x32,0x89,0xa5,0x25,0x5c,0x44,0x86,0x41,0x66,0x34,0x86,0x56,0x38,0xd0,0x99,
0x1c,0x81,0x99,0x09,0x90,0x75,0x07,0x98,0x99,0x8e,0xa1,0xf7,0x88,0xad,0x8b,0xa0,
0xc8,0xc2,0xcf,0x00,0x00,0xe8,0x75,0x0b,0xba,0x85,0xb9,0x29,0xc6,0x4c,0xb3,0xb0,
0x45,0xce,0x0b,0x3b,0x87,0x30,0xe1,0xfe,0x35,0xe0,0x67,0xc1,0xf8,0x83,0xa5,0x91,
0x2f,0x1e,0x09,0xe1,0x71,0xe4,0x74,0x5a,0xbd,0xe8,0xf0,0x75,0x91,0x7b,0xcb,0x34,
0xfb,0xe5,0x9a,0xf5,0x21,0xb9,0x44,0x36,0xa4,0x1e,0xa9,0x17,0x29,0x44,0x46,0x46,
0x11,0x7b,0x95,0x6b,0x98,0x55,0xaf,0x62,0x5a,0xda,0xd2,0xd3,0x6b,0x48,0xba,0x54,
0x5d,0x2e,0xad,0x23,0xa3,0x6e,0x76,0xc7,0x6c,0x77,0xe9,0x66,0x9f,0xeb,0xff,0xdf,
0x78,0x0f,0x18,0x1b,0x16,0x0e,0x7d,0xd4,0xe3,0xda,0x7f,0xc9,0x1e,0xc8,0x88,0xd9,
0xa1,0x5e,0x87,0x9f,0x63,0x76,0x94,0xf9,0xca,0xea,0xf4,0xb2,0x19,0x14,0x54,0x13,
0x45,0x54,0x7b,0xb4,0x7d,0xe4,0xa0,0xf1,0x09,0xc7,0x2d,0x06,0x9f,0x42,0x5f,0x59,
0x33,0xb5,0xd9,0x52,0x98,0xf9,0x42,0x4f,0xd2,0xf3,0x54,0x9d,0x72,0x8b,0x31,0x4a,
0x5b,0x05,0x6b,0x41,0xf7,0x2c,0xc5,0xd3,0x09,0x74,0xb1,0x33,0xd1,0x7b,0x62,0xea,
0x66,0xa6,0x39,0x14,0xbf,0x4f,0xb3,0x53,0x35,0x7f,0xee,0x70,0x00,0x00,0x00,0x01,
0x09,0xc2,0xe0,0x2b,0x24,0x20,0xe5,0x90,0x92,0x27,0x38,0x54,0x99,0xb4,0xde,0x09,
0xe1,0xe8,0x78,0x2d,0x69,0x82,0xa9,0xa8,0xd3,0x55,0xe6,0xdf,0x7b,0x6f,0xbd,0xb7,
0x93,0xcb,0xbe,0x9d,0x2e,0xf6,0x77,0xef,0x0f,0xbe,0xbc,0x2d,0x7c,0xb8,0x59,0x79,
0x67,0xe7,0xe4,0x42,0xf8,0x39,0xba,0xee,0xf0,0xcd,0x2c,0x3c,0x14,0xe4,0x05,0xe0,
0xa5,0x66,0x06,0x84,0xd2,0x99,0xad,0x21,0xce,0x99,0x89,0xf1,0xcc,0x8c,0xc6,0x2a,
0x46,0x92,0x8c,0x95,0x49,0x12,0x91,0x03,0xb2,0xc0,0x77,0xb6,0x74,0x1d,0x88,0xa0,
0x00,0x00,0x00,0x49,0xff,0xfb,0x92,0x00,0x03,0x00,0x03,0x0f,0x64,0xe0,0xea,0x61,
0x1b,0x7a,0x56,0xa3,0xcb,0xb2,0x61,0x22,0x4a,0x0c,0xd9,0xa3,0x7f,0xa7,0x88,0x6d,
0xe9,0x63,0x27,0x6f,0x68,0xf2,0x89,0x79,0x25,0xca,0x1c,0x50,0x1c,0x4a,0x6c,0x2f,
0xc9,0x68,0xec,0xcb,0x53,0x17,0xa5,0x27,0x06,0xe4,0xa2,0x96,0x7a,0xd5,0x4d,0xcf,
0x04,0x9d,0xee,0x59,0xc9,0xc7,0xe5,0xd2,0xd7,0xbf,0x3c,0xbc,0xf6,0xe1,0xf3,0xcf,
0xcb,0x3f,0x2e,0xfd,0xe9,0x65,0xe7,0xd3,0x20,0xdc,0x33,0x4a,0x63,0xc8,0x46,0xbc,
0xcc,0x1e,0x49,0x71,0xaa,0xda,0x29,0x01,0x19,0x25,0x83,0xc3,0x4c,0x54,0x04,0x46,
0x0f,0x53,0x67,0x4c,0x6b,0x5d,0xc2,0xeb,0x90,0x27,0x31,0x17,0x1e,0x34,0x65,0x20,
0x59,0x75,0x59,0x6a,0x00,0x05,0x4b,0xe8,0x0c,0xfa,0x66,0x36,0xd9,0xbd,0xbc,0xfe,
0xbe,0x56,0x0e,0xed,0x9c,0xe7,0x1f,0xd0,0x7e,0x7f,0xad,0x9d,0x6e,0x96,0xc3,0xe3,
0x51,0xa5,0xae,0x1f,0x11,0xbc,0xd5,0x78,0x29,0xfa,0xd6,0xc7,0xd2,0x49,0x95,0x25,
0xce,0xa1,0xae,0x52,0x2f,0xad,0x8f,0xd2,0x71,0x2b,0x2a,0x79,0xcd,0x2e,0xd4,0x28,
0xaa,0x07,0xc6,0xb1,0x8f,0x16,0x40,0xa3,0x96,0x39,0xa3,0x1a,0x92,0x4d,0x42,0x92,
0x35,0xea,0x00,0xb4,0xdb,0x10,0x81,0xd5,0xfa,0x7e,0xe2,0x61,0x00,0x00,0x00,0x04,
0x94,0x52,0x87,0xb8,0x05,0x4f,0xcb,0x33,0xc7,0x09,0x7f,0x2c,0x5f,0x03,0x7e,0x2c,
0x16,0x3d,0x4d,0x56,0x96,0x99,0x28,0x5a,0xb4,0xd5,0xc8,0xf2,0xd1,0xed,0x5c,0xed,
0x35,0x1e,0xdc,0xbc,0x2d,0xba,0x59,0xf1,0x64,0x32,0x59,0x3c,0xc8,0xda,0xd2,0x25,
0xe1,0xe4,0x64,0xd6,0x91,0xb7,0x67,0x99,0x2c,0x86,0x4c,0xb6,0x5a,0x46,0xd2,0x19,
0x29,0x95,0x94,0x8d,0xad,0x23,0x33,0x2b,0x21,0x92,0xca,0x9e,0x47,0x2d,0x1c,0x95,
0xb7,0x4c,0xcc,0x15,0xa3,0x1b,0x29,0xba,0x63,0xa8,0x59,0x07,0x38,0xa6,0x97,0x26,
0x07,0x03,0x00,0x00,0x00,0x00,0x43,0x90,0xf7,0x00,0xa9,0xf9,0x66,0x78,0xe1,0x37,
0xdb,0xdc,0x70,0xc0,0x3d,0x80,0xb0,0xa7,0x8f,0xa9,0xa7,0x68,0xad,0x1e,0xd4,0x5a,
0xb4,0xd5,0x6b,0x6b,0x47,0x96,0xad,0xb5,0x37,0xae,0xfb,0x53,0x6a,0x6f,0xbd,0x76,
0xa6,0xdb,0x57,0x7a,0xfd,0xa9,0xb5,0x73,0xd5,0xd5,0x2c,0xd4,0xc9,0x57,0x55,0xbb,
0xd1,0xa4,0x91,0x90,0x15,0xc7,0x5d,0x8f,0xb3,0x1a,0xa1,0x46,0xf3,0x2c,0xbd,0x0c,
0x69,0x4a,0x92,0xcd,0x5a,0xea,0x4a,0x45,0x4a,0x9b,0x02,0x00,0x00,0x00,0x00,0x00,
0x26,0x5b,0x19,0x1a,0xc4,0xeb,0xff,0xfb,0x92,0x00,0x06,0x00,0x03,0x32,0x67,0xde,
0xeb,0x05,0x13,0x72,0x5b,0x6d,0x1c,0x6d,0x44,0x23,0x6f,0x4c,0xa9,0x93,0x7f,0x47,
0x88,0x6d,0xe9,0x68,0x8b,0x6e,0xe5,0x85,0x94,0xe0,0x1b,0x75,0xf2,0x84,0xfd,0x0d,
0xbf,0x9a,0xe7,0xcf,0xc2,0xb1,0x5a,0x8a,0x46,0xbc,0x7d,0x1e,0x6c,0x7c,0x6e,0xd5,
0x6a,0x6f,0x4c,0xdb,0x57,0x6a,0x3d,0x37,0xa6,0xdb,0x57,0x7a,0x66,0xa3,0x57,0x6a,
0xb5,0x37,0xa6,0xdb,0x57,0x6a,0x1a,0x6a,0x0e,0xe0,0xd6,0x33,0x2b,0x42,0xe3,0xb8,
0x24,0x9a,0xa3,0x30,0x35,0x8c,0xc1,0xd2,0x64,0x8e,0xe0,0x92,0x25,0x94,0xb0,0xab,
0x1d,0xc1,0x24,0xce,0x8e,0xc0,0xd6,0x33,0x1c,0xb3,0x24,0x77,0x04,0x8a,0x66,0x52,
0xb2,0xac,0x66,0x41,0xe2,0xf1,0x00,0x08,0x40,0xa4,0x9c,0xbb,0x93,0x20,0xac,0x62,
0x54,0x9f,0x48,0x88,0xce,0xa7,0x56,0xf2,0xc3,0xa9,0xee,0x4e,0x5b,0x9f,0xd4,0xb7,
0x2c,0xb5,0x3f,0xb9,0x79,0xf3,0xef,0x97,0x7c,0xfc,0xf9,0xe5,0xdf,0xbe,0x5a,0x4a,
0x67,0x9f,0x6c,0x22,0x7b,0x2f,0x99,0xa4,0xa6,0x66,0xb1,0xec,0x22,0x79,0x7d,0x4c,
0xd2,0x02,0x22,0x3b,0x1e,0xc3,0x31,0x12,0xe6,0xb9,0x3d,0x04,0x44,0x76,0x14,0x5c,
0xc6,0x4b,0x93,0x68,0x74,0x14,0x21,0x92,0x96,0xb9,0x8c,0xf2,0x6d,0xc3,0xa0,0xec,
0x28,0x00,0x00,0x00,0x01,0x4e,0x0c,0xa0,0x43,0xd8,0xf5,0x4b,0xf4,0x2b,0xe5,0xa7,
0xc3,0xd7,0x81,0x05,0x86,0xa0,0xdb,0xc9,0x47,0x83,0xa9,0xaa,0xf7,0xda,0x7c,0x94,
0xcb,0xb6,0xf7,0xa3,0xd7,0xa7,0xc3,0xcf,0xcb,0x4f,0xf9,0xeb,0xe5,0xfe,0x7d,0x23,
0x07,0xd3,0xe1,0x63,0xca,0x5a,0x72,0xf0,0x8d,0x6e,0x3e,0x8f,0xb9,0x83,0x22,0x05,
0xd3,0x8c,0x98,0xd6,0x8c,0x41,0x36,0xa6,0x0d,0x0c,0x4d,0xc7,0x8f,0x18,0x59,0x83,
0xc8,0x34,0x83,0xa3,0x26,0x35,0x86,0x41,0x36,0xcc,0x1d,0x21,0x37,0x1e,0x3c,0x52,
0x30,0x79,0x25,0x09,0xb5,0x00,0x00,0x00,0x00,0x15,0x10,0x88,0x66,0xf5,0x94,0x75,
0xef,0xe3,0x8d,0xe8,0x87,0x72,0x5a,0xd2,0x3b,0x32,0x25,0xe5,0x5c,0x02,0xca,0x3e,
0x18,0xa8,0x3e,0x27,0x54,0x8d,0x79,0xb1,0xd1,0x31,0xc7,0x2d,0x24,0x1e,0xb5,0xb4,
0xfb,0xe8,0x3d,0x52,0x98,0xe5,0xa4,0x93,0xeb,0x61,0xfa,0x90,0xe7,0x29,0x4d,0x72,
0xcb,0xa4,0x6c,0x73,0x18,0xf1,0x44,0x0f,0x70,0xa8,0x0d,0xa6,0x56,0x5d,0x23,0x2b,
0x20,0xc3,0x4a,0x40,0xf7,0xb4,0x06,0xd4,0x47,0x12,0x19,0xa1,0x89,0x5a,0x2f,0x01,
0xdf,0x70,0xff,0x48,0xdf,0x55,0x39,0xe3,0xff,0xfb,0x92,0x00,0x04,0x80,0x02,0xe0,
0x1d,0xdd,0x0b,0x09,0x2a,0x50,0x5b,0xa5,0x5b,0xa1,0x61,0x62,0x4c,0x0b,0xc0,0x91,
0x74,0xac,0x1c,0x49,0x41,0xa1,0xb4,0x6f,0x69,0x22,0x8d,0xb9,0x2d,0xfa,0x8f,0x75,
0x83,0xad,0xd1,0x0d,0x07,0xb3,0x8d,0xf4,0xa7,0x47,0x37,0xa3,0xe9,0x3e,0x28,0xec,
0x19,0x61,0xf1,0xd4,0x1d,0x2b,0xc5,0x63,0x1a,0x25,0x4c,0x64,0xa1,0x13,0x95,0x13,
0x65,0x4b,0x63,0x94,0x58,0x93,0xa8,0x4b,0x9e,0xa4,0xb2,0xa5,0xb6,0x2a,0x58,0x9b,
0xa0,0x54,0xbd,0xf4,0x9f,0x7a,0x8b,0xb6,0x2a,0xb6,0x9d,0xad,0x2f,0x31,0x4c,0xc4,
0xbb,0x6c,0x5b,0x45,0x2a,0x4b,0x1d,0x4d,0xdf,0x57,0x55,0x9e,0xee,0xef,0xec,0x05,
0xdf,0x70,0xdf,0x48,0xdd,0x15,0xc7,0xc6,0x5b,0xf3,0x0f,0x74,0x8b,0x5f,0x04,0x98,
0x22,0x79,0x07,0xa8,0x7e,0x0a,0x2f,0x2f,0xe1,0x7d,0x6b,0xa3,0x2d,0x47,0x89,0xa3,
0x41,0xd0,0xb0,0x58,0x2a,0x3d,0x1e,0x4a,0x3d,0xb1,0xb7,0x96,0x8d,0x4a,0x15,0x01,
0x50,0x4c,0xe4,0xa1,0x26,0x54,0xc6,0x39,0x48,0xba,0x64,0x91,0xca,0x98,0x2f,0x52,
0x05,0xdc,0xa4,0x24,0xdc,0xc9,0x27,0xd4,0xc1,0x7a,0xad,0x7d,0x09,0x37,0x32,0x97,
0xd7,0x17,0x8b,0x5b,0xef,0xd3,0xae,0xdf,0xf7,0xff,0x6a,0x00,0x01,0xd7,0xc8,0x0c,
0x91,0x58,0x01,0x4e,0x7d,0x9d,0x7c,0x72,0xb4,0x20,0x24,0xa0,0x93,0x88,0x1a,0x22,
0x61,0xf1,0x53,0x30,0xe5,0x0b,0xc3,0x32,0x16,0x09,0xe3,0xd1,0xa1,0x31,0xe8,0xd0,
0x74,0x1e,0x66,0x96,0x8f,0x7a,0x34,0x1c,0xbb,0x1f,0x2e,0xc3,0xaf,0x97,0x63,0xe5,
0xd8,0xfa,0x58,0x77,0x24,0xc7,0xb5,0x2c,0x78,0xba,0x18,0xfa,0x09,0x32,0xb4,0x31,
0x02,0xe8,0x65,0x68,0x46,0xb4,0x05,0x10,0xb4,0x04,0x10,0xb4,0x75,0xa0,0x62,0x16,
0x8d,0x7f,0xbe,0xbb,0xeb,0xff,0xdf,0xff,0x6b,0x00,0x00,0x00,0x00,0xca,0x96,0x89,
0xe4,0x02,0xe0,0x88,0x91,0x83,0x16,0x39,0xd2,0xc2,0xa5,0xc3,0xf2,0xb4,0x2b,0x10,
0xc7,0xc6,0x34,0x98,0xf9,0xa8,0x7a,0x3c,0xd4,0xc9,0xbd,0x33,0xef,0x4d,0x77,0x9b,
0x97,0x06,0xd8,0xaa,0x08,0x88,0x3f,0x9f,0x3e,0xf9,0xf3,0xef,0x4b,0x6e,0x7d,0xf3,
0xe1,0x77,0xcb,0x84,0x40,0xfa,0x34,0x62,0x45,0x2a,0x59,0x58,0x44,0x0e,0xe3,0x48,
0x44,0x0e,0xd1,0xa2,0xa9,0x05,0xe9,0x42,0x68,0xa4,0x0d,0x4c,0x69,0x46,0x20,0x74,
0xc4,0x4a,0x64,0x0f,0x71,0xa2,0xb1,0xa9,0x52,0x62,0x95,0x88,0x1d,0x34,0x94,0xcc,
0x1d,0x00,0x02,0xa5,0x3a,0x01,0x16,0x91,0xa2,0x39,0xff,0xfb,0x92,0x00,0x04,0x80,
0x02,0xa8,0x1c,0xdd,0x93,0x09,0x12,0x50,0x66,0xcb,0xeb,0xd6,0x3c,0xa3,0x6f,0x4c,
0x8d,0xa3,0x7d,0x2c,0x08,0x6d,0xe9,0x6b,0x8f,0xae,0x85,0x94,0x89,0x28,0xdb,0x70,
0x77,0x41,0x08,0xc0,0x5a,0x16,0x24,0xc3,0x8e,0xe4,0xfd,0x39,0x79,0xbb,0xab,0xfb,
0xe0,0xf1,0xe0,0xb1,0xa9,0xbb,0x52,0x8d,0x4c,0x77,0xd6,0x44,0xed,0x64,0x8e,0x39,
0x45,0x1a,0xf5,0x16,0x26,0xfa,0xd2,0xce,0xea,0x90,0xc7,0xc7,0x24,0x52,0x92,0x67,
0xea,0x43,0x0d,0x8a,0x01,0x18,0x31,0x65,0xc9,0x9f,0x8d,0x22,0x3c,0xd0,0xa1,0x86,
0x3a,0xb4,0xd4,0x96,0xbe,0xb4,0x0b,0x1a,0x6b,0xbf,0xa0,0x00,0x00,0x36,0x3d,0x80,
0x04,0xd0,0xf4,0x35,0xb2,0x7e,0xf9,0x16,0x34,0xba,0xa7,0x70,0x85,0x34,0x5e,0xa9,
0x76,0x8d,0xc7,0xc6,0xe2,0xd1,0x8f,0x15,0xa3,0xcd,0x92,0x8d,0x25,0x5e,0xad,0x36,
0xf5,0xf1,0xf0,0x7e,0x5c,0xf2,0xec,0xe1,0x69,0xe7,0xdf,0x6e,0x91,0xad,0x86,0x75,
0xf4,0xe1,0x69,0xc5,0xf2,0x20,0x53,0x18,0x81,0xdc,0x78,0x0f,0x26,0xb0,0xcd,0x5f,
0x73,0x85,0x84,0xd8,0x4d,0x04,0x44,0xd2,0x8c,0x41,0xa6,0x39,0x83,0xa4,0x2e,0x52,
0x72,0x76,0xaf,0x8e,0x40,0xa6,0x32,0x82,0xcc,0x52,0xb4,0x24,0x99,0xbc,0xe3,0xce,
0x20,0x24,0x00,0x00,0x00,0x2b,0xa6,0x26,0x9c,0xf3,0x60,0x85,0x71,0xd2,0xe7,0x64,
0xdf,0x5f,0x9a,0xaf,0x04,0xd1,0x35,0x1a,0x0f,0x36,0x3c,0x95,0x4a,0x34,0x7a,0x3c,
0x1e,0x5d,0xa7,0xae,0xaf,0x6a,0x3d,0x3c,0xf8,0x5b,0xf0,0xb6,0xf2,0xef,0xaf,0x9f,
0x3e,0x74,0xf3,0xe1,0xc9,0xeb,0xe5,0xbf,0x2d,0xa6,0x43,0x74,0x6a,0x0b,0xc5,0x79,
0x90,0x49,0x16,0x31,0x18,0xf0,0x19,0x50,0xb1,0x06,0x3a,0x64,0x96,0x9a,0xa9,0x98,
0xb8,0x0b,0xda,0x98,0xc6,0xe8,0x76,0x42,0x22,0xd4,0xa8,0x3c,0x9a,0xe6,0x49,0x6c,
0x90,0x8c,0xe4,0x38,0x0e,0x00,0xf0,0xf1,0x18,0xf2,0x24,0xec,0x85,0x71,0x91,0x73,
0x37,0x37,0x91,0x9e,0x91,0x1d,0x07,0x9d,0xc9,0x76,0x23,0x96,0x5f,0x3a,0xde,0xdf,
0x10,0xea,0x44,0x04,0xd1,0x54,0x1e,0x1e,0x85,0xa3,0x4f,0x52,0x41,0xe2,0x5c,0xb2,
0x81,0xea,0x96,0x45,0xd5,0x12,0x3e,0xe5,0xa5,0x8f,0xa1,0xba,0x50,0x7a,0xb4,0xbd,
0xca,0x51,0xc3,0x72,0xad,0x75,0x0c,0x17,0x70,0xe4,0x32,0xa4,0xde,0x2c,0xa4,0xba,
0xb6,0xbc,0xc5,0x02,0xcf,0xa5,0x99,0x94,0xeb,0x46,0xad,0xfb,0x1f,0xfa,0x3f,0xef,
0x62,0x10,0x00,0x00,0x00,0x00,0x21,0x38,0x9b,0xa0,0x84,0x62,0xff,0xfb,0x92,0x00,
0x06,0x00,0x03,0x37,0x63,0xdf,0xeb,0x02,0x1b,0x7a,0x57,0x83,0x2b,0xc9,0x61,0x22,
0x38,0x4a,0xc4,0x73,0x76,0x4c,0x24,0x49,0x41,0xae,0x31,0xae,0xcd,0x82,0x8d,0xb8,
0xd9,0x22,0x9b,0x78,0x7e,0xed,0x9f,0xa1,0xef,0xda,0x82,0x68,0x6a,0x0d,0x57,0x97,
0x79,0xb1,0xb6,0xb6,0xf6,0xde,0xad,0x26,0xd4,0xcf,0x47,0xaf,0x4b,0x9f,0x39,0xf7,
0xef,0x7d,0xb8,0x7c,0xf5,0xe9,0xeb,0xe7,0xc2,0xcf,0xcb,0x2f,0x3f,0x3c,0x5d,0xa3,
0x47,0x5c,0x44,0x86,0x4f,0x21,0x90,0x3c,0xd3,0x06,0x46,0x0b,0x4a,0x40,0xc8,0x81,
0xe0,0xf3,0x05,0x5d,0x9c,0x11,0x12,0xc7,0x18,0x82,0xb1,0x8a,0x78,0x5b,0x5c,0x68,
0xad,0x8d,0x31,0xe9,0xdc,0x6a,0x34,0xa2,0x85,0x50,0x7e,0x98,0x00,0x00,0x00,0x1f,
0xa8,0xa8,0x30,0x98,0xa8,0xf4,0x53,0x6f,0x0f,0x97,0x33,0xc1,0xdd,0xb4,0x5c,0xe3,
0xb9,0x17,0xa1,0x30,0xaf,0x13,0x51,0xe6,0xc4,0xd1,0xa5,0xc7,0xb3,0xc7,0xda,0xdf,
0xcb,0xdf,0xfb,0x9d,0x9d,0xf8,0x4a,0xff,0xee,0xdc,0xef,0xd7,0xbf,0xf7,0xee,0xfd,
0x69,0xff,0xf3,0x96,0x75,0x19,0x1a,0xaf,0x52,0x4e,0x77,0x18,0x92,0xda,0x6c,0xeb,
0xef,0x8c,0x5b,0x5d,0x6e,0x71,0xfb,0x62,0x52,0x8a,0x55,0xb2,0xef,0xa7,0x57,0x6a,
0xdb,0xdb,0x60,0x00,0x54,0xf0,0x04,0xa6,0x71,0x85,0x3d,0x9e,0xd8,0xb5,0x25,0x97,
0xe9,0x03,0xf8,0xee,0x1c,0x3d,0xce,0xda,0x53,0xea,0x6f,0x3f,0xed,0xf0,0xb4,0x3c,
0x1b,0x47,0xa8,0xf0,0x55,0x4a,0xb4,0xf8,0xce,0xa0,0x89,0xca,0x88,0xbd,0xd2,0x8d,
0x7a,0xd2,0x87,0xd6,0xd7,0x69,0x65,0x48,0xb9,0x65,0x18,0x11,0x9b,0x41,0xc8,0xb9,
0x33,0xa6,0xe5,0xda,0xb5,0x01,0x12,0xf8,0xa3,0x02,0x46,0x68,0x64,0x54,0x06,0x87,
0x56,0xd0,0xaa,0x46,0x24,0xfc,0x5d,0x1e,0xc0,0x00,0x04,0xb9,0x1e,0x00,0x92,0xce,
0x2d,0xa7,0xb3,0xdb,0x26,0xa4,0xb3,0xfd,0x96,0x5f,0xf9,0x0b,0x05,0x0e,0x85,0xaa,
0x0b,0xc8,0x3e,0x2d,0x1a,0x3e,0x36,0x82,0xf3,0xb4,0x5a,0xaf,0x19,0x92,0xad,0x7a,
0x34,0x66,0x4d,0xed,0xe5,0xcf,0x7f,0x3c,0xbd,0xbb,0xef,0xc2,0x23,0x2d,0xbb,0xe9,
0xe5,0xe5,0xaf,0x3e,0x79,0x79,0x9a,0xd9,0xe1,0xee,0x39,0xd3,0x35,0x97,0xc1,0xdc,
0x73,0x83,0x10,0x69,0x64,0x07,0x0c,0x41,0x41,0x88,0x34,0x6b,0x41,0x31,0x88,0xf1,
0xcc,0x2d,0x96,0x82,0x62,0x7c,0x87,0x35,0x7e,0x4a,0x44,0xf9,0x0e,0x02,0x10,0x18,
0x24,0x10,0xab,0xec,0x60,0x00,0x00,0x00,0x53,0x52,0xe7,0x48,0x33,0x71,0xff,0xfb,
0x92,0x00,0x05,0x00,0x03,0x2c,0x68,0xdf,0x53,0x02,0x1b,0x72,0x59,0xc2,0xcb,0xa1,
0x61,0x67,0x38,0x0c,0x9d,0x87,0x83,0xa7,0x84,0x6d,0xe9,0x77,0xb2,0x31,0xbd,0x10,
0x8d,0xbd,0x67,0xa9,0xec,0xf8,0x2f,0xf1,0x93,0xea,0x6b,0x9f,0x6e,0x83,0x42,0x63,
0xc1,0x62,0x2a,0xf2,0x6f,0x5d,0xaa,0xf5,0xda,0xbb,0x53,0x56,0x96,0x8f,0x7e,0x5e,
0x9e,0xdc,0x3d,0xba,0x9e,0x7b,0x70,0xb5,0xc9,0x2e,0x7d,0xf2,0xef,0xbf,0x97,0x7c,
0xb9,0x9b,0xc8,0x46,0x0b,0xc7,0x80,0xb3,0x7b,0x4c,0xa7,0x9e,0x0f,0x22,0xb5,0x88,
0x11,0x62,0x7a,0x44,0x4f,0x14,0xe9,0x6b,0xa9,0xb3,0x23,0x56,0xa2,0x10,0x36,0xc3,
0xc6,0x23,0x4b,0x8e,0x80,0xa9,0x8f,0x41,0x99,0x25,0xa3,0xa0,0x39,0xf0,0x1d,0x91,
0x02,0xef,0x16,0x7a,0x98,0xe6,0x6c,0xff,0xd1,0x09,0xc0,0xb9,0x96,0x20,0xf3,0x03,
0x28,0x24,0x72,0x1f,0x13,0x63,0x12,0xaf,0x1c,0x75,0x25,0x2a,0xd2,0x32,0xb3,0xe3,
0x0a,0x92,0x3a,0xe5,0x8b,0x3d,0xcb,0x2c,0x45,0xcb,0x43,0x5d,0x51,0x33,0x95,0x25,
0x8f,0x97,0x63,0xeb,0x43,0x72,0x27,0x9c,0xb5,0x3a,0xb2,0xc4,0x9e,0xc4,0x31,0xf1,
0xa9,0x0b,0xa1,0x49,0x6b,0x9a,0x39,0xae,0xad,0x0c,0x7d,0x0c,0x7d,0x5d,0x2c,0x77,
0x7d,0x68,0xe8,0x6b,0xaa,0xea,0x4b,0x1f,0x0c,0x00,0x02,0x04,0x00,0x0a,0x8e,0x91,
0x90,0x05,0xc6,0xf9,0x6f,0x68,0xe5,0xd3,0xe2,0x7f,0x7d,0x7c,0x49,0x47,0x31,0x44,
0xa3,0x9b,0xb9,0x82,0x6e,0xe7,0x9e,0xe7,0xbd,0xcf,0x72,0xcf,0xcf,0xbe,0x5e,0x7d,
0xf2,0xe1,0xf7,0xcb,0x9e,0xbe,0x78,0x4e,0x14,0x86,0x53,0x85,0xa7,0x2f,0x04,0xe0,
0x18,0x42,0x43,0x57,0x43,0x04,0x44,0x22,0xd4,0x30,0xcb,0x88,0x97,0x36,0xb4,0x8c,
0x11,0x98,0xf6,0x91,0xb5,0xc7,0xb7,0x36,0xb4,0x75,0x07,0x98,0xab,0x48,0x81,0xc3,
0x1e,0x83,0x23,0x59,0x8e,0xa1,0xcf,0x48,0x04,0xc8,0xb6,0xd0,0x34,0x91,0x89,0x08,
0x11,0x92,0x49,0x38,0xee,0xe1,0xdd,0x00,0x98,0x3a,0xc8,0x39,0x2d,0x21,0x95,0x1f,
0xa6,0xd5,0x49,0x47,0x32,0x92,0xb9,0xef,0x53,0xdc,0xd4,0xf7,0x3c,0xb7,0x3d,0xee,
0x7e,0x7d,0xfb,0xe7,0xdf,0xbe,0x7b,0xf4,0xb2,0xf7,0xe9,0xe5,0xcf,0xbe,0x5c,0xf5,
0xf3,0xe6,0x4b,0x21,0x90,0x2c,0x86,0x90,0xc9,0x6e,0x34,0x99,0x2c,0xc9,0x82,0x68,
0xb1,0x14,0xd3,0x85,0x13,0x78,0x70,0xb4,0x90,0xcd,0x97,0x4c,0x16,0x67,0x69,0x18,
0x2a,0x43,0xda,0x46,0xd7,0x1a,0x83,0xba,0x5b,0x25,0x01,0xe8,0x89,0xc5,0x83,0x97,
0xff,0xfb,0x92,0x00,0x03,0x00,0x02,0xc6,0x22,0x5d,0x0b,0x2c,0x12,0x50,0x66,0x8c,
0xfb,0xd6,0x48,0x43,0x6f,0x4c,0x61,0xa1,0x85,0xa9,0x04,0x6d,0xe9,0x77,0x32,0xf0,
0x68,0xf0,0x8d,0xbd,0xdb,0x1d,0xeb,0x23,0xdc,0x11,0x5b,0x46,0x9b,0xe1,0x37,0xb1,
0x03,0x11,0x7e,0xa8,0xe4,0xf5,0x96,0x26,0x1f,0x85,0x54,0x12,0xf1,0xe2,0x2a,0x34,
0x22,0x2a,0x41,0xbc,0xb8,0xf6,0x79,0x28,0xf0,0x50,0xf3,0xd4,0xb6,0x9c,0x97,0x43,
0xaa,0x43,0x6b,0x2e,0x45,0xd2,0xa4,0x1b,0x59,0x23,0xe6,0xa9,0x3b,0x14,0x5b,0x1f,
0x36,0x97,0xc5,0x1a,0xc7,0xa8,0xdd,0xf2,0xad,0x5d,0x49,0x72,0x29,0x6c,0x5d,0x4c,
0x74,0xc5,0xd5,0xfa,0x3d,0xbe,0xed,0x00,0x00,0x00,0xb9,0xe0,0x7e,0x92,0xc2,0xd6,
0x36,0x63,0x97,0x2c,0x2a,0x4a,0xa6,0xa2,0xed,0x06,0x89,0xc6,0x87,0x69,0x20,0xf0,
0xaa,0x82,0x6a,0xf1,0xb1,0xa4,0x79,0x20,0xf5,0xab,0xca,0xf6,0xde,0x4e,0xa6,0x0f,
0xdb,0xa7,0xaf,0x8f,0xc3,0xd3,0xbf,0x3d,0xba,0x64,0xde,0x39,0xc3,0x37,0xb0,0xf0,
0x52,0xb7,0x08,0x85,0x78,0xe6,0xeb,0x1e,0x82,0xf0,0x56,0x11,0x31,0x10,0xe7,0x91,
0x3d,0x87,0x41,0x5e,0xd8,0x44,0xd9,0x8c,0x59,0x13,0xd8,0x48,0x0e,0xc5,0xb0,0x8d,
0x73,0x18,0x9c,0x89,0x12,0x96,0x0e,0xc5,0x6a,0xe6,0xa5,0x8c,0x48,0x2a,0x88,0x80,
0x00,0x00,0x14,0x51,0x93,0x05,0xfa,0x03,0xdd,0x48,0x5d,0x8f,0x32,0x01,0x38,0x54,
0xa0,0xf3,0xfa,0x8b,0x53,0xce,0x79,0x6e,0x4e,0xf5,0x7a,0x9b,0x8a,0x6e,0x59,0xc9,
0xc7,0xe5,0xe5,0x97,0x9f,0x3d,0xb9,0xf7,0xbf,0x7d,0x38,0x79,0x79,0xff,0x9f,0x0b,
0xbf,0xf7,0x20,0x96,0x19,0x84,0x73,0x1e,0x63,0x63,0x48,0x35,0x0a,0xe4,0xc4,0x0f,
0x20,0x5b,0x39,0x83,0xcd,0xe5,0x1b,0x2b,0x8d,0x69,0x93,0x48,0x3a,0x02,0xda,0x98,
0x32,0x30,0xf1,0x46,0x54,0x73,0x1a,0xe3,0xc6,0x90,0x4a,0x02,0x43,0x5c,0x2e,0x40,
0xfb,0x90,0x00,0x00,0x12,0x8b,0x74,0x77,0x00,0x0b,0x8c,0x59,0xa5,0x7a,0x19,0xe4,
0x70,0xf4,0xdf,0x9e,0x4a,0x29,0x29,0xe7,0x3c,0x1b,0xdd,0xea,0x5a,0x9e,0x53,0xcb,
0x1e,0xef,0xcb,0xa5,0xaf,0x7e,0x7c,0xe1,0xef,0xd3,0xcc,0xb2,0xe9,0xeb,0xd3,0xe7,
0xce,0x1e,0xfe,0x5e,0x58,0xd6,0x8f,0xad,0x26,0xc1,0x66,0x0f,0x86,0x60,0xc8,0x92,
0xe5,0x95,0xc7,0x90,0xc9,0xb8,0x46,0x0f,0x67,0x3a,0x44,0x96,0x0d,0x49,0xf1,0xe4,
0x44,0x68,0xc4,0x60,0xf2,0xad,0x48,0x92,0x98,0xf7,0x7c,0x75,0x09,0xa4,0x23,0x90,
0x00,0x00,0xff,0xfb,0x92,0x00,0x02,0x00,0x03,0x07,0x5e,0x60,0x69,0xe2,0x1b,0x7a,
0x5d,0x0a,0xfc,0x6f,0x34,0x43,0x6f,0x4c,0x4d,0x91,0x83,0x49,0x08,0x6d,0xe9,0x7f,
0x2f,0xf0,0x69,0x01,0x0d,0xbd,0x00,0x08,0x21,0xb8,0x93,0x01,0x5a,0xe7,0xc9,0x97,
0x44,0x3f,0xf7,0x5d,0xbb,0xf8,0x98,0xd0,0xb4,0x7d,0xe6,0xae,0x7c,0xd4,0xc9,0xb5,
0x77,0xde,0xb5,0x6d,0xa6,0xa6,0xde,0x5c,0xf3,0xe9,0xf7,0xcb,0x85,0xce,0x9e,0xbf,
0x78,0x79,0xf4,0xfb,0xe5,0xc2,0xe7,0x97,0x4f,0x07,0x20,0xe4,0xca,0xf2,0xd2,0x31,
0x52,0x14,0x08,0x64,0x34,0x06,0x74,0x3e,0x63,0xad,0x5d,0x2e,0x31,0xb5,0x96,0x43,
0x25,0x93,0xae,0x46,0x3d,0x07,0xe9,0x90,0xcc,0x0a,0x9f,0xaa,0x91,0x0b,0xce,0x94,
0xbb,0x0c,0xfe,0x65,0x48,0x00,0x00,0x64,0x4d,0x27,0x14,0xbb,0x8f,0xe0,0x67,0x26,
0x45,0x18,0x74,0x07,0x3e,0xd5,0x6d,0xb4,0x1d,0x1f,0x7a,0x55,0xaf,0x53,0x53,0x6a,
0x35,0x77,0xae,0xbb,0x53,0x4d,0xeb,0xcb,0xc2,0xdb,0xbe,0xfe,0x5c,0xff,0xcf,0xbe,
0x7e,0x7c,0xe9,0x66,0x46,0xb2,0x1e,0x5c,0x5b,0x48,0xc7,0xe9,0xd0,0x59,0x0d,0xc2,
0xe7,0x99,0x29,0xf6,0x52,0x36,0xb6,0x5a,0x64,0x26,0x02,0xe2,0x66,0x3d,0x07,0xef,
0x98,0xcc,0x0a,0x99,0xda,0x11,0x4b,0x45,0x49,0x66,0xac,0xf4,0x9a,0xa1,0xcc,0x2d,
0x3c,0x00,0x00,0x04,0x22,0x9c,0xa4,0x04,0x0b,0xa1,0xa8,0xdd,0x1b,0x6a,0x1c,0x15,
0x9a,0xd3,0x6a,0xf6,0x82,0xde,0x9b,0x55,0xa5,0xda,0x8d,0x3d,0x36,0xd3,0x7a,0x6d,
0x5d,0xa9,0xf8,0xfc,0x3d,0x3a,0x7a,0x7d,0xf2,0xef,0x9f,0x3c,0xf8,0x7a,0xf4,0xba,
0x66,0xf6,0x11,0x3d,0x8b,0xe6,0x60,0xa6,0x39,0x83,0xb8,0xc4,0x0c,0xb5,0xe1,0xd6,
0x22,0x7a,0x0c,0xcd,0x25,0x63,0x45,0x20,0x77,0x18,0x81,0xd2,0x1c,0xc1,0x36,0x2b,
0x42,0x8a,0x66,0x22,0x53,0x27,0xb0,0x95,0xd4,0xa4,0xc7,0x30,0x53,0x1c,0x81,0xee,
0x14,0xc2,0x96,0x10,0x10,0x01,0x10,0x83,0x94,0x99,0x04,0x61,0xa8,0xdd,0x24,0xe4,
0xe4,0xe9,0xad,0x36,0xaf,0x68,0x2d,0xe9,0x96,0xad,0x5d,0xa9,0xbd,0x32,0xbc,0x95,
0x79,0x36,0xae,0x5d,0xe9,0xe7,0xcf,0x2e,0xff,0xef,0xc2,0xdf,0x87,0xa1,0xf3,0xcf,
0xbe,0x5d,0xf3,0xe1,0xf3,0xcf,0xa6,0x62,0x25,0xcc,0xd5,0x2d,0x84,0x41,0xe5,0x1c,
0xe3,0x6d,0xd1,0xb0,0xb4,0xc6,0x40,0x68,0x43,0xb8,0x23,0x26,0x57,0x49,0x4c,0xd2,
0x51,0x89,0xd6,0x2a,0xd2,0x30,0x53,0x1c,0xc1,0x4c,0x62,0x98,0x49,0xec,0xc8,0x4d,
0x6a,0x18,0x01,0xd5,0xff,0xfb,0x92,0x00,0x01,0x00,0x02,0xde,0x21,0xdd,0x0b,0x0b,
0x2a,0x50,0x5b,0x83,0xfb,0xa1,0x61,0x65,0x4a,0x0b,0x04,0x5b,0x76,0xcc,0x30,0xa7,
0x01,0xa2,0xb4,0x6f,0xe9,0x22,0x8d,0xbd,0x48,0x60,0xb7,0x1b,0xaa,0x9f,0xe3,0x6f,
0xc8,0x36,0x5f,0x62,0xd7,0xc8,0xfd,0xc9,0x1b,0x25,0xea,0xc6,0x55,0x59,0x9c,0x2a,
0xb4,0x2a,0x82,0xb7,0x1d,0x14,0xa3,0xc6,0x63,0xa8,0xf1,0x3a,0x34,0xaf,0x1f,0x47,
0x8d,0xac,0x99,0xf7,0xcb,0x35,0xea,0x43,0x75,0x21,0xd5,0x21,0xce,0xa9,0xae,0x6a,
0x49,0xb2,0xb4,0x84,0xab,0x4b,0x9e,0xb1,0xcc,0x74,0xb3,0x0e,0x68,0x62,0x54,0x87,
0xbd,0x63,0x5a,0x3e,0x35,0xaf,0xd2,0xd4,0x29,0x3f,0x75,0x5f,0x66,0x9f,0xeb,0xfe,
0xcb,0x3c,0x07,0x55,0x21,0x82,0xdc,0x67,0xaa,0x7f,0x8c,0xdf,0x92,0x58,0xbd,0x8a,
0xe6,0x47,0xee,0x08,0xd0,0x4b,0xd5,0x66,0x55,0x59,0x74,0x4a,0xd0,0x85,0x0b,0x33,
0x47,0x51,0xe3,0x31,0x5d,0xe7,0xa3,0xc6,0xe3,0xe4,0x4f,0xbd,0x04,0x5a,0xf5,0x20,
0xf5,0x45,0x10,0xea,0x9a,0xe7,0x52,0xc7,0x2d,0x2d,0xac,0xb9,0x21,0xb5,0xb0,0xe3,
0xe8,0x63,0xd4,0x86,0x54,0xa4,0x0f,0xa9,0xa7,0xde,0xd4,0xb4,0xc8,0xaa,0x78,0xe4,
0x8c,0xa9,0x8c,0x73,0x50,0xcd,0x3d,0x77,0xff,0x6f,0xea,0xfe,0xdb,0x50,0x00,0x00,
0x15,0x46,0xc6,0xe5,0x07,0xcb,0x14,0xff,0x1c,0xcf,0x64,0x67,0xee,0x47,0xc6,0x93,
0x0a,0x2c,0x51,0xf5,0x0c,0x9c,0x74,0x52,0xa3,0xa7,0x64,0x17,0xab,0x4f,0x41,0xf1,
0x31,0xf7,0x2c,0xa1,0x17,0x4a,0x11,0x73,0xd4,0x97,0x3e,0x97,0x3e,0x94,0x3e,0x94,
0x3d,0xd4,0x3d,0xd4,0x5d,0x02,0x93,0x74,0x0a,0x4c,0xe9,0xb5,0xa4,0xeb,0xd6,0x55,
0x8e,0x16,0x2a,0x40,0x2c,0xc5,0x10,0x17,0x8a,0xac,0x5e,0x2e,0xb6,0xd8,0xb6,0x8a,
0x31,0x4d,0x14,0x8a,0xa9,0x8e,0xa0,0x10,0x00,0x00,0x21,0xb8,0x5f,0x05,0x68,0x7b,
0x2a,0x0c,0x56,0x21,0x2b,0x25,0xec,0xf2,0xd6,0x39,0x01,0x1d,0x87,0x5d,0xad,0xb5,
0xf1,0xfb,0x5f,0x7b,0xef,0xbd,0xb7,0xde,0xdb,0xdb,0xcb,0xa7,0x97,0x96,0xfe,0x5d,
0x2d,0xf8,0x5b,0xf9,0xf0,0xf7,0xf3,0xe1,0xe7,0xc3,0xd3,0xcb,0x86,0x42,0x2a,0x8c,
0xe1,0x0d,0x44,0x50,0x64,0x62,0xea,0x88,0x70,0xe4,0x62,0xe0,0x32,0x70,0xf1,0x85,
0xa0,0x2c,0xde,0x43,0x40,0x95,0x9e,0x02,0x32,0x4b,0x4d,0x02,0x52,0x4a,0x0c,0x91,
0x2a,0x93,0x83,0x86,0x96,0x93,0x87,0x91,0xe8,0x34,0x37,0x90,0xd0,0x3c,0x00,0x02,
0xa6,0x62,0x06,0x85,0x96,0x88,0xff,0xfb,0x92,0x00,0x04,0x00,0x02,0xb3,0x1c,0xdd,
0x93,0x07,0x12,0x50,0x67,0x6c,0xfb,0xc7,0x48,0xa3,0x6e,0x4c,0x91,0xa3,0x81,0x48,
0x08,0x6d,0xe9,0x87,0x2c,0xef,0xa5,0x81,0x0d,0xbd,0xd4,0xbd,0xce,0xdd,0x47,0xba,
0x0a,0x18,0x80,0xfe,0xa3,0x12,0x54,0x23,0x13,0xe3,0x7a,0x96,0x95,0xd4,0xd0,0x79,
0x31,0xe5,0x79,0xa8,0xf3,0xe3,0xb9,0x49,0x22,0x7e,0xa2,0x4f,0x7a,0x94,0xc7,0xd0,
0x43,0x5a,0x1d,0x5d,0xae,0xa5,0x95,0x15,0x48,0x5d,0x23,0x09,0x9e,0x7b,0x50,0xd3,
0x62,0xe8,0x22,0xf8,0xf2,0x03,0x6b,0x63,0x0c,0x8a,0x25,0x88,0x59,0x52,0x63,0x98,
0x00,0x69,0xeb,0x50,0x2a,0x95,0x23,0xd9,0xf0,0x00,0x00,0x01,0x32,0x50,0xfc,0x40,
0xf8,0x0d,0x46,0xa0,0xc5,0x8d,0x29,0x80,0xf5,0x1f,0xaa,0x27,0xea,0x19,0x0f,0x50,
0xb0,0xbc,0x5f,0x1d,0x11,0xaa,0x46,0xb4,0x95,0x1f,0x1b,0xa5,0x1e,0xf5,0x7a,0x67,
0xde,0xfe,0x5d,0xf7,0xf2,0xef,0xde,0xf9,0x79,0x77,0xe7,0x0f,0x2f,0x3e,0x7c,0xf3,
0xcf,0xcb,0x99,0x3d,0xc6,0x8c,0x48,0xa4,0x0c,0x8d,0x2e,0x32,0x05,0x33,0x9d,0x23,
0x49,0x8e,0xe0,0x8c,0xd2,0x43,0xa7,0x76,0x30,0x59,0x3d,0xa3,0xd6,0x54,0x52,0x07,
0x93,0xdc,0x64,0x0a,0x66,0xa4,0x0c,0x99,0x26,0x3a,0x03,0x33,0x05,0x20,0xea,0x4a,
0x38,0x00,0x00,0x01,0x40,0x37,0x45,0xe0,0x05,0xa8,0x0f,0xc3,0x49,0x63,0x45,0x67,
0x15,0x4d,0xa9,0x55,0xa5,0xa3,0xd5,0xe9,0xb4,0x16,0xd5,0x79,0xea,0xf4,0xda,0x9b,
0x55,0xea,0xd3,0x51,0xed,0x65,0xe1,0x6d,0xd1,0x89,0xa6,0x7e,0x7d,0xf2,0xe7,0x97,
0x0b,0x7f,0x3e,0xf9,0x73,0xcb,0xfe,0x91,0x34,0xa4,0x4a,0xf2,0xbe,0x39,0x83,0x94,
0x62,0x0c,0x9a,0x15,0x3c,0x3d,0xc7,0x30,0x73,0x18,0xa1,0x69,0xa8,0xa8,0x0c,0x88,
0xe5,0xdd,0x1d,0x96,0xc1,0xc8,0x34,0xa4,0x4c,0x96,0xbe,0x39,0x83,0xb8,0xe4,0x09,
0x34,0x28,0x35,0x0f,0x52,0x40,0x00,0x00,0x05,0xb6,0xc0,0x0a,0x2e,0x0d,0x91,0xe6,
0xdb,0xab,0xba,0x0d,0x7d,0xfb,0xdb,0xad,0x51,0xa1,0x68,0x3d,0x5e,0x4a,0x34,0x16,
0x34,0x1e,0x7a,0xbc,0x99,0x68,0xf6,0xaf,0x6a,0x6f,0x5f,0x3e,0x96,0x9e,0x5c,0xf3,
0xef,0x9f,0x4b,0x9e,0x5c,0x32,0x69,0x61,0x19,0x76,0xc1,0xcc,0x2d,0x86,0x50,0xb4,
0xe0,0xd8,0x3f,0x1c,0xef,0xbf,0x0b,0x86,0x6b,0x69,0x13,0x4b,0x13,0x33,0xb6,0x0e,
0x61,0x6d,0x22,0x89,0xa7,0x8e,0x60,0xe9,0x0e,0xc0,0xe7,0xc2,0x20,0xca,0xd2,0x4c,
0x49,0x51,0x74,0xb7,0xba,0xd4,0x42,0xa4,0xff,0xfb,0x92,0x00,0x01,0x00,0x02,0xe9,
0x5d,0x63,0x7a,0x42,0x1b,0x7a,0x5f,0x2c,0x7c,0x6f,0x48,0x43,0x6f,0x4c,0x55,0x93,
0x8b,0xa7,0x88,0x6d,0xe9,0x7c,0xb0,0xf0,0x29,0x11,0x09,0xbd,0x10,0x01,0x31,0x16,
0x9b,0x55,0xdd,0xc9,0xa0,0x54,0xd2,0x1f,0x89,0x44,0x48,0x35,0x4d,0x5e,0xd5,0x68,
0x2d,0xe9,0xae,0xd3,0xd0,0xbb,0xc9,0x5d,0xf3,0xd3,0x7a,0xb5,0x76,0xa6,0x9e,0x7c,
0xfb,0xe5,0xdf,0x6f,0x3d,0x3a,0x59,0x97,0x64,0x2c,0xbb,0xf7,0xcf,0x9e,0xde,0x7d,
0xf5,0xe9,0x50,0x5e,0x3f,0x0f,0x92,0x11,0xb9,0x76,0x51,0xc9,0x2d,0x94,0x88,0xde,
0x4d,0x98,0x89,0x28,0x3c,0x86,0xd4,0xe0,0x2c,0xc7,0xe1,0xd5,0x84,0x33,0xac,0x76,
0xea,0x43,0x3f,0x69,0x4d,0x25,0x5f,0xa1,0x42,0x08,0x00,0x99,0x13,0x49,0x36,0xae,
0xe5,0xe0,0x5c,0xd2,0x1f,0x8b,0xcc,0x41,0xaa,0x3d,0x5e,0xd5,0x68,0x2a,0xbd,0x1e,
0xbb,0x4f,0x45,0xab,0xda,0xba,0x6f,0x4d,0xf6,0xae,0xdb,0xd3,0xcf,0x85,0xde,0x16,
0x7f,0x3b,0xe5,0xdf,0x9e,0x7c,0xfb,0xe5,0xdf,0x3f,0x3e,0x79,0xf9,0x1b,0xc8,0x46,
0x46,0x49,0x69,0x91,0x70,0xe4,0xcc,0x78,0x0c,0xa8,0x5c,0x86,0x70,0x7e,0xd7,0x1d,
0x01,0x58,0xad,0x91,0xbc,0x86,0x44,0x64,0x96,0x99,0x9c,0x63,0x93,0x31,0xad,0x2a,
0xb9,0x0c,0x82,0xce,0xdd,0x49,0xab,0xd0,0x20,0x43,0x45,0x36,0xdb,0xbb,0x8c,0x90,
0x26,0x2a,0x7b,0x1a,0x9d,0x0d,0xfe,0x6f,0xad,0xfd,0xd5,0xab,0xa4,0x16,0x6d,0xad,
0xbd,0x1e,0x7a,0xeb,0x9a,0x8d,0x6d,0xbc,0xf4,0x7a,0xf7,0xe1,0xed,0xe5,0x97,0x97,
0x0f,0xbd,0xfb,0xe7,0xc2,0xcf,0xcb,0x87,0xa7,0x3e,0xf9,0xf4,0xf1,0x57,0x1a,0x3a,
0xe2,0x20,0x23,0x20,0x7c,0x22,0x07,0x9b,0x5a,0x3d,0x1e,0xd1,0xa0,0x2a,0x61,0x30,
0x59,0x03,0x88,0xa9,0x5b,0x1e,0xd1,0xd5,0xd4,0xd1,0x81,0x66,0x0b,0x42,0x45,0x63,
0x1a,0x63,0xd7,0xb4,0x94,0x1e,0xd3,0xa8,0x4b,0xb2,0x00,0x00,0x00,0x82,0x1b,0x81,
0xd5,0x02,0x91,0x11,0x7c,0x3c,0x47,0x37,0x2d,0x59,0xe6,0xf5,0x69,0xea,0xd0,0x59,
0xa8,0xd2,0xe3,0xef,0x3d,0x5a,0xba,0x53,0x2e,0xd5,0x7b,0xef,0x3e,0xd4,0xd2,0x9a,
0xed,0xbd,0xea,0xf5,0xd2,0x9a,0x6d,0x5d,0xb7,0xbe,0xd5,0x67,0x05,0x04,0xcc,0x1a,
0xc2,0x51,0x5e,0x3a,0x20,0xea,0x72,0xb9,0x20,0xd9,0xc1,0x48,0x56,0x56,0x61,0x29,
0x1d,0x5d,0x63,0xaa,0xb3,0x92,0x4b,0x82,0xb1,0x48,0xaf,0x2a,0x47,0x53,0x95,0xce,
0xaa,0xce,0x08,0xc9,0xe4,0x23,0xa6,0xd8,0x91,0x34,0xff,0xfb,0x92,0x00,0x01,0x00,
0x02,0xbc,0x5b,0xe3,0x6a,0x22,0x13,0x7a,0x59,0xa8,0xdc,0x7d,0x48,0xa2,0x5d,0x4d,
0x1d,0x87,0x7d,0xac,0x08,0x6d,0xe9,0x78,0x32,0xf1,0x74,0xf1,0x0d,0xbd,0x08,0x80,
0xb2,0xda,0x8a,0xee,0x4c,0x02,0x3a,0x68,0x43,0x8b,0x52,0x6a,0xb4,0x6a,0xd5,0x5c,
0x46,0xde,0xde,0x95,0x4a,0x69,0xb5,0xb6,0xda,0x6a,0x35,0x34,0xa6,0x9b,0x7b,0x6d,
0x4d,0x69,0x92,0xaf,0x26,0xdb,0x7b,0x53,0x5a,0x69,0xb6,0xee,0xd4,0x66,0x2a,0xca,
0xa9,0x91,0x51,0xdc,0x8e,0xec,0xd1,0xdc,0xaa,0x85,0x28,0x23,0xd5,0x51,0xdc,0x22,
0x4e,0xe8,0xee,0xd8,0xee,0x55,0x95,0x53,0x06,0xb2,0xa6,0x8b,0x1e,0xe5,0x67,0x24,
0x3d,0xeb,0x3d,0x7b,0x5c,0x60,0x9c,0xdb,0x4e,0x39,0x76,0xe4,0x30,0x0b,0xa9,0x50,
0x75,0x12,0xd2,0x05,0x3a,0x8d,0x59,0x2a,0xd0,0x23,0xda,0x8d,0x2d,0x34,0xaa,0x53,
0x6d,0xbd,0xa9,0xa5,0x34,0xdb,0x7b,0x6d,0x47,0xad,0x34,0xde,0x8f,0x6d,0xeb,0x96,
0x8d,0x06,0xa8,0xf4,0x7b,0xee,0xe5,0xcb,0x53,0xc1,0xaa,0x3b,0x87,0x58,0xb7,0xbb,
0xb5,0x47,0x70,0x6a,0xf5,0xfd,0x3c,0xad,0x51,0xd9,0xca,0xae,0x91,0x73,0xd6,0xa2,
0x35,0x3d,0xa9,0x24,0xea,0xed,0x49,0x89,0xfd,0x56,0x24,0xad,0x6a,0x28,0x08,0x00,
0x00,0x00,0x00,0x00,0x54,0x5e,0x40,0x75,0xba,0xd6,0xdf,0x2f,0x74,0x7e,0x86,0xdf,
0xdf,0xbd,0xaa,0x58,0x36,0x8f,0x42,0xc1,0xb4,0x7a,0x34,0x3e,0x34,0x13,0x4f,0x8d,
0x05,0x9f,0x69,0x68,0xfb,0x4b,0x47,0xbf,0x0b,0xbe,0x7c,0x2e,0xf9,0xf3,0xdf,0xcf,
0x9e,0xfe,0x5b,0x70,0xfc,0xb6,0xe1,0xe7,0xe5,0xc3,0xc7,0x90,0x8c,0x27,0x8f,0x21,
0x1b,0xdc,0x79,0x33,0x79,0x8e,0x41,0xb6,0x79,0x99,0x37,0x0c,0xcd,0x2b,0x10,0x23,
0x31,0xe4,0x1c,0x82,0x53,0x1e,0x02,0x22,0x09,0x4c,0x74,0x05,0x9a,0x2e,0x3a,0x06,
0x38,0x34,0xf2,0x44,0x8b,0x13,0x7d,0xc4,0x40,0x8c,0x92,0x5b,0x4a,0xde,0xa6,0x05,
0xba,0x15,0x19,0x35,0xcf,0xdf,0x2d,0xfe,0xf5,0xf3,0x56,0x8a,0xa1,0x6a,0xd7,0xa6,
0xbb,0x53,0x7d,0xa9,0xbf,0xae,0xf4,0xd7,0x79,0xb9,0xf4,0xf6,0xe7,0x9f,0x9f,0x3c,
0xfc,0xf9,0xe7,0xcf,0x9e,0x7c,0xf2,0xf3,0xe7,0x9f,0x99,0x06,0xe1,0xc5,0x75,0x9c,
0x3d,0xbb,0x92,0x3e,0x2a,0x03,0xc9,0x2d,0x32,0x05,0x91,0x5a,0x64,0x0b,0x21,0xad,
0x32,0x96,0x0d,0x42,0xe4,0x8b,0x9d,0x5d,0x49,0x49,0xf5,0xe9,0x29,0x55,0x63,0x06,
0x84,0x32,0xf5,0x26,0xe1,0x00,0x00,0x00,0x02,0x0d,0xd1,0x15,0xff,0xfb,0x92,0x00,
0x04,0x00,0x03,0x22,0x68,0xe0,0x52,0x02,0x1b,0x7a,0x5e,0x64,0x9b,0x90,0x61,0x62,
0x4a,0x0c,0x51,0x9f,0x83,0x47,0x88,0x6d,0xe9,0x5b,0x8c,0x6e,0xc9,0x84,0x94,0xe0,
0x03,0xe3,0x31,0xae,0x4b,0x47,0x55,0x65,0xb9,0x67,0x3f,0x06,0xd2,0xd1,0xea,0xf2,
0x53,0x6a,0x2e,0xd2,0x51,0xab,0x9b,0x6a,0x6f,0x5d,0xe9,0xaf,0x9f,0x4b,0x2e,0x79,
0x75,0x38,0x5a,0x70,0xf7,0x23,0x6b,0x97,0x7c,0xfb,0xe5,0xc3,0xef,0x9f,0x0b,0x1a,
0x02,0xc9,0x95,0xd0,0xe1,0x69,0xb9,0xd7,0x23,0x6b,0x99,0x03,0x86,0x3d,0x07,0x90,
0x99,0x0c,0x82,0xcc,0x63,0x05,0x90,0xd2,0x47,0x65,0x74,0x30,0x45,0xbe,0xed,0x5d,
0x4d,0x53,0x1d,0x41,0xc3,0x1e,0x02,0x32,0x59,0x0c,0x83,0x5f,0xd3,0x6c,0xce,0x89,
0x5b,0x3f,0x56,0x9c,0x97,0xd7,0xcc,0xb5,0x79,0x07,0xdb,0x62,0x67,0x91,0x4c,0xb1,
0xdb,0xc1,0x0f,0x90,0x37,0x96,0x66,0x1c,0x4b,0xa0,0xb8,0x61,0xa0,0x10,0x4d,0x3b,
0x2a,0x63,0x42,0x54,0x78,0x76,0x9a,0x8f,0x07,0x8f,0x07,0x3a,0xe5,0x95,0x63,0xaa,
0x41,0xe9,0x42,0x07,0xde,0xb6,0x3e,0xb4,0xb5,0xcb,0x4b,0x5d,0x52,0x0e,0xd4,0x86,
0x3e,0xbe,0x5c,0x9b,0x76,0xbe,0xa4,0x31,0x0b,0x43,0x1d,0x5a,0x5d,0x52,0x5a,0xff,
0xfe,0xea,0x90,0xb4,0xa9,0x0d,0x7c,0x7c,0x6d,0x69,0x60,0x79,0x02,0x00,0x02,0x4a,
0x72,0xd4,0x2c,0x26,0x49,0xa0,0x76,0x60,0xe7,0x13,0xee,0x6d,0xf8,0x95,0xc3,0x6f,
0xbc,0xf4,0xcd,0xbd,0x5a,0xb4,0xd7,0x6a,0xb5,0x6a,0xfb,0xda,0x9a,0x79,0xf9,0x6f,
0xcf,0x9e,0x5e,0x5b,0xf3,0xef,0x97,0x4b,0x09,0x29,0xf4,0xf3,0xe1,0xe0,0xa5,0x6e,
0x11,0x0b,0xb0,0xf0,0x77,0x12,0x59,0x13,0xca,0x58,0x3b,0x89,0x28,0x39,0x84,0x96,
0x40,0x64,0x43,0x9c,0x1c,0xc1,0x48,0xab,0x08,0x87,0xb0,0x90,0x1d,0x8a,0xb9,0x1a,
0x4a,0x50,0x1d,0xd8,0xf1,0xcd,0x23,0xca,0x09,0x09,0x8f,0x1c,0xd3,0x80,0x01,0x54,
0xb4,0x9e,0x92,0x15,0xb6,0xf6,0xf5,0xb0,0xed,0x40,0x96,0xa1,0x7f,0x12,0x61,0xd7,
0x73,0x9e,0xc1,0x9d,0x87,0xc5,0xe3,0x1e,0x24,0x8a,0x2d,0xb4,0xf4,0xc6,0xe3,0xaa,
0x2e,0x97,0xd4,0xd3,0x8f,0x41,0x26,0xd6,0x87,0xb9,0x4b,0x20,0xfa,0x58,0xca,0x92,
0xea,0xd4,0xc7,0x4b,0x34,0x2f,0x03,0xa0,0xf4,0x50,0x91,0xf3,0x72,0xac,0x1b,0x30,
0x93,0xb1,0x72,0x2e,0x32,0x28,0x86,0xb9,0x66,0xd8,0xa1,0x45,0x12,0x7a,0x45,0x5a,
0x2c,0x66,0x63,0xee,0x22,0x00,0x00,0x00,0x00,0x01,0x59,0x44,0x03,0x7d,0xff,0xfb,
0x90,0x00,0x05,0x00,0x03,0x1a,0x63,0xdf,0x61,0xe2,0x1b,0x7a,0x62,0x8c,0x3c,0x3f,
0x48,0x22,0x6f,0x4b,0x90,0x73,0x74,0x2c,0x24,0x49,0x41,0x73,0x0b,0x2e,0xd9,0x84,
0x94,0xe0,0x8b,0x38,0x34,0x4c,0x76,0xab,0x75,0xef,0x88,0x70,0x78,0x3a,0x92,0x0b,
0x4a,0x60,0xea,0x48,0x3c,0x94,0x78,0x2c,0xf5,0x69,0x2a,0xd4,0xcf,0x47,0xaf,0x4b,
0x9e,0x9c,0x3d,0xfc,0xfa,0x5a,0x70,0xb9,0xef,0xd2,0xdf,0xa5,0xc3,0xd2,0xc3,0xdf,
0xcb,0xa4,0x42,0x2c,0x1c,0xd1,0xcc,0x5c,0xa4,0x42,0x25,0x1a,0xa3,0xe2,0xe4,0x1f,
0x79,0x8d,0x61,0x63,0x5c,0x78,0xf0,0xc7,0x99,0x63,0x58,0x35,0x27,0xc7,0x99,0x43,
0x98,0xd4,0x9f,0x1a,0xe7,0x0e,0x63,0x43,0x2d,0xb6,0x99,0xd4,0xa4,0xcc,0x00,0x00,
0x04,0x14,0x89,0x56,0x60,0xc7,0x80,0xc6,0x52,0x17,0x63,0x9a,0x5c,0x1a,0x92,0xc2,
0xa7,0x34,0xe7,0x9e,0xa5,0x82,0x4e,0x7a,0x9a,0x82,0x4e,0x0d,0xcd,0x41,0xa9,0x6f,
0x77,0xb7,0xb6,0xfe,0xfb,0x5b,0x6f,0x7d,0xa6,0xda,0xaf,0x6a,0xbc,0xdb,0x50,0x8e,
0x02,0xaa,0x39,0x02,0xa9,0x45,0x20,0x26,0x70,0xb4,0x63,0x83,0x56,0x31,0x16,0xc0,
0xa6,0x2b,0x83,0xba,0xd6,0xc0,0xa5,0x46,0x05,0x75,0xad,0xc1,0xca,0x46,0x04,0xec,
0x11,0x4c,0xee,0x0e,0xc7,0x32,0xb3,0x04,0x1c,0x56,0x52,0xea,0xd0,0x98,0x07,0x6e,
0xe0,0xb9,0x45,0xd3,0xb5,0xef,0xe3,0x33,0xf8,0xf3,0xd9,0x86,0x8f,0x4c,0x35,0x61,
0xff,0xc8,0x37,0x05,0xba,0xce,0xd5,0x69,0x2d,0x88,0x76,0x13,0x06,0xf0,0xf4,0x1e,
0xed,0x34,0x1e,0x7c,0x63,0xca,0x41,0x13,0x95,0x11,0x7b,0x96,0xa6,0xbe,0x5d,0x8e,
0xa1,0x2c,0xa9,0x0f,0xad,0x4c,0x7c,0xbb,0x4f,0x4c,0xa5,0xb5,0x21,0xce,0x16,0x53,
0x0c,0x4b,0xb4,0xed,0xe9,0x6d,0x48,0xbc,0x51,0x4c,0x31,0x5b,0x42,0x37,0xa4,0x5e,
0xb4,0x75,0xdd,0xfa,0x1b,0xa7,0xae,0xef,0xed,0xfb,0x48,0x00,0x00,0x15,0x3c,0x60,
0xf3,0x4b,0xd5,0x45,0xef,0xe3,0x73,0xf2,0xc1,0x0e,0x4c,0xe9,0x8a,0xac,0x3f,0x9d,
0x06,0xe0,0x64,0x49,0x9c,0x6c,0x60,0xfb,0x39,0x05,0x63,0x73,0xe3,0xcf,0x29,0x04,
0x9b,0x52,0x0e,0x39,0x65,0x48,0x3a,0xb6,0xbe,0x82,0x4d,0xa9,0x0c,0xa8,0xaa,0x1d,
0x59,0x37,0xd6,0xc0,0xb1,0xb7,0xa0,0x51,0xc2,0xa0,0x42,0x27,0x05,0x94,0x4d,0xf5,
0xb0,0x2c,0x6e,0x5c,0x51,0xca,0x32,0x4c,0x51,0x83,0x10,0x7e,0xb4,0x8c,0x36,0xd5,
0x8b,0xba,0x65,0x82,0xda,0x3f,0xef,0x25,0x00,0x00,0x00,0x40,0x49,0x45,0x28,0xff,
0xfb,0x92,0x00,0x04,0x00,0x03,0x23,0x64,0xdf,0xd1,0xe2,0x1b,0x7a,0x56,0x28,0xab,
0xc6,0x60,0xe2,0x5c,0x4c,0xd9,0x87,0x7f,0xa7,0x88,0x6d,0xe9,0x87,0x33,0xf0,0x75,
0x31,0x0d,0xbd,0x11,0x1c,0x4c,0xd4,0x1f,0x3f,0x31,0xda,0x3b,0x5f,0xee,0xa0,0xf3,
0xd0,0xb5,0x69,0xa8,0xf3,0x50,0xf5,0x7a,0x6f,0x5d,0xab,0x92,0x8d,0x56,0x96,0x8f,
0x37,0x3f,0x3e,0x79,0xf3,0xcb,0xbe,0x9e,0x5d,0xf2,0xe9,0x10,0xf6,0x52,0x32,0x26,
0xe0,0xf8,0x6d,0x05,0xca,0x66,0x92,0x8e,0x60,0xee,0x31,0x03,0xcc,0xac,0x22,0x75,
0xd7,0x87,0xb7,0x1e,0xc3,0x34,0x99,0x98,0x29,0x8d,0x2e,0x69,0x29,0x13,0xae,0xa5,
0x4b,0x6d,0x0d,0x58,0x8a,0x4c,0x73,0x05,0x08,0x74,0x06,0x65,0x15,0xad,0x3f,0xe8,
0x00,0x00,0x8f,0xdd,0x10,0xee,0x45,0x5a,0x2b,0x9f,0xa7,0x43,0x5d,0x83,0xb9,0x06,
0x9b,0x0c,0xb0,0x9f,0x2f,0x43,0x67,0xb4,0x7a,0x85,0xe3,0xd9,0x3a,0xbc,0xca,0xbc,
0x1e,0xd5,0xda,0x9d,0xab,0xbd,0x37,0xa3,0xc9,0x57,0xa6,0x34,0x1e,0xd5,0xdd,0xab,
0xb5,0x37,0xa6,0xdb,0xd3,0x7a,0x96,0x5a,0xb5,0xd9,0x17,0x6a,0xe3,0xba,0xc9,0xe7,
0x29,0xaa,0xd5,0x35,0xfc,0xe3,0xf7,0x42,0xf7,0x75,0x9b,0x90,0xa2,0xb5,0xa9,0x67,
0xf3,0x1f,0xdd,0x0b,0xd9,0x85,0x00,0x00,0x00,0x00,0x00,0x02,0x1b,0x84,0x68,0x03,
0xd6,0xc5,0x6a,0x6f,0xa7,0xfc,0xb1,0x7d,0x77,0xe3,0xc1,0xbc,0x4d,0x07,0x83,0xcb,
0x47,0x83,0xc5,0x51,0xeb,0x57,0xb6,0xb5,0x7b,0xd1,0xeb,0xbd,0x1e,0xbe,0x7d,0xfb,
0xe7,0xbf,0x2f,0x4f,0x7e,0xfa,0xf9,0xf7,0xd7,0xcf,0xbe,0xbe,0x7d,0xf3,0xf1,0xcc,
0x3e,0x0c,0xd0,0x9e,0x39,0x83,0x72,0x1e,0xc1,0xcc,0x1d,0x21,0xda,0x19,0x83,0xb8,
0xf0,0x19,0x98,0x3b,0x47,0x8f,0xb5,0x7a,0xf8,0xb9,0x73,0x5b,0x8e,0xc0,0xc8,0xd6,
0xe3,0xb0,0x3c,0x96,0xe3,0x98,0x73,0x42,0xc9,0x9e,0xf2,0x88,0xed,0x04,0x80,0x00,
0x00,0x10,0x49,0x6e,0x84,0x22,0x00,0x0a,0x94,0x08,0x09,0x2f,0x20,0x73,0xa6,0xb4,
0x5e,0x6f,0x07,0x97,0x7a,0xe5,0xde,0xb9,0xb7,0x9e,0xbb,0x67,0xae,0xfb,0xd7,0x7d,
0xeb,0xe7,0xe7,0xbf,0x4f,0x3f,0x3e,0xf9,0xf4,0xfb,0xe7,0xe5,0xdf,0x3f,0x2e,0xf4,
0xf3,0xf2,0xe9,0x90,0xf2,0x91,0x03,0xa4,0x3c,0xa4,0x40,0xba,0x3c,0x72,0x24,0x2a,
0x79,0xca,0x85,0x1f,0x39,0x48,0x81,0x4c,0x79,0x48,0xa4,0xc7,0x8e,0x8b,0x12,0x24,
0x78,0xa4,0x40,0x90,0xc7,0x6a,0x44,0x1a,0x63,0x4a,0x45,0x24,0x1a,0xa6,0x76,0x04,
0x40,0xff,0xfb,0x92,0x00,0x01,0x80,0x03,0x0a,0x68,0xe0,0xd2,0x22,0x1b,0x7a,0x5f,
0xac,0x8c,0x1a,0x44,0x43,0x6f,0x4b,0x35,0x6f,0x8d,0xa6,0x84,0x6d,0xe9,0x8e,0x34,
0x30,0x69,0x01,0x0d,0xbd,0x00,0x49,0x31,0xd3,0x70,0x7a,0x25,0xc6,0x70,0x85,0x8e,
0x64,0xea,0x73,0x95,0x9c,0xab,0xc3,0x55,0xf7,0xbe,0xf2,0x6d,0x4d,0x2b,0xa6,0xfb,
0xdb,0x7a,0x6d,0x4d,0x3b,0x3a,0x5b,0x74,0xf2,0xf3,0xf3,0xd3,0xa7,0xcf,0x9d,0xf9,
0xd3,0xe9,0xe7,0xe7,0xa7,0x97,0x0c,0x82,0x50,0x72,0x86,0xae,0x2a,0xd3,0x21,0x39,
0x8e,0x48,0x64,0x22,0xc3,0xd2,0xd9,0x41,0x96,0xd6,0x99,0x2e,0x63,0xf9,0x92,0x5a,
0x68,0x12,0xd4,0xa0,0xfc,0x35,0xa6,0xaa,0x64,0x2b,0xcc,0x92,0xa8,0xc8,0x09,0xc9,
0x2d,0xe8,0x2b,0xdd,0x91,0x10,0x00,0x90,0x4b,0x74,0xdc,0x1e,0x89,0x71,0x9c,0x21,
0x63,0x99,0x3a,0x6f,0x30,0x75,0x9c,0xae,0x1a,0xaf,0x57,0xbe,0xf6,0xda,0x8f,0x25,
0x74,0xd2,0xaf,0x2e,0xfb,0xdb,0x79,0x3c,0xbb,0xf3,0xbf,0x7c,0xfa,0x79,0x79,0xff,
0x97,0x4b,0x4e,0xfd,0xf9,0xd3,0xd7,0xcb,0xcc,0x86,0xf1,0x8d,0x0c,0x92,0x83,0x2c,
0x1d,0xbd,0x07,0xeb,0x29,0x92,0xe4,0x31,0xd3,0x24,0xe9,0x1b,0xca,0x94,0x1f,0xd9,
0x0d,0x42,0xc2,0x12,0xd0,0x88,0x6c,0x86,0x37,0x43,0x4b,0x49,0xc1,0xc9,0x68,0x39,
0x11,0x48,0x13,0x5d,0xa4,0x80,0x19,0x49,0x37,0x65,0xbc,0x3a,0x80,0x06,0x11,0x19,
0x86,0xe8,0x99,0xd6,0x7e,0x96,0xd3,0xcf,0x52,0x75,0xb8,0xb5,0x2c,0xe7,0x9e,0xb7,
0x7b,0x96,0x72,0xcf,0xcb,0xcb,0x2e,0x9f,0x3a,0x9c,0x3d,0xed,0x1f,0x62,0xd7,0xa7,
0xde,0x97,0x3d,0x3c,0xf6,0xf2,0xe1,0x15,0xe9,0x1b,0xdc,0x69,0x9e,0xd2,0x99,0x82,
0xca,0xf0,0xc9,0xee,0x53,0x2d,0x65,0x33,0x99,0xc3,0x86,0x4f,0x71,0xeb,0x2e,0xa9,
0x4c,0x81,0xf1,0x92,0x44,0x41,0x73,0x96,0xa7,0x4c,0xbc,0x92,0x7d,0xb0,0x00,0x08,
0x24,0x14,0xe5,0x11,0x88,0x01,0x88,0x8d,0xc1,0xea,0x2e,0x35,0xac,0xb7,0x49,0xa8,
0xd5,0xe0,0xea,0xd4,0x7b,0x6f,0x35,0x0b,0x4d,0x6a,0xd7,0xda,0xaf,0x35,0x74,0xcf,
0xbd,0xfc,0xbb,0xf7,0xbf,0x3c,0xbc,0xf3,0xf3,0xe7,0xde,0x91,0x3d,0xc6,0xd4,0xf5,
0xe9,0x98,0x2e,0x3f,0x1b,0x1e,0xe3,0x6d,0xa2,0x90,0x3c,0xc2,0x5a,0x51,0x1b,0x1e,
0xd1,0xcc,0x36,0x94,0x81,0xc2,0x7b,0x46,0x84,0xd8,0x94,0x06,0x66,0x1b,0x4d,0x82,
0x42,0x17,0x72,0xda,0xa1,0x10,0x3c,0xef,0x48,0xd2,0x63,0xca,0xc6,0xd6,0x11,0x02,
0x67,0xb0,0x00,0xff,0xfb,0x92,0x00,0x01,0x80,0x03,0x0e,0x61,0xe1,0xea,0x01,0x1b,
0x7a,0x5f,0xca,0x2b,0xed,0x60,0xa2,0x5e,0x4b,0xc0,0x7f,0x74,0xac,0x18,0x49,0x41,
0x82,0x14,0xee,0x41,0x94,0x89,0x30,0x00,0x82,0x9a,0x26,0x5c,0x35,0x00,0x65,0x40,
0x7e,0x22,0xc9,0x8e,0x0a,0x8f,0xce,0xef,0x37,0x06,0xa5,0x8f,0x73,0xdc,0x94,0xb5,
0x0e,0x7b,0x86,0x6a,0xd4,0x52,0x75,0xc2,0xe7,0x9f,0x7d,0xfc,0xb9,0xe5,0xe7,0xdf,
0x3e,0x9f,0x3c,0xb9,0xf7,0xcf,0xbe,0x7e,0x58,0x29,0x46,0x25,0xb2,0xd8,0x66,0xb2,
0xe4,0xe4,0x4d,0x01,0x19,0x8d,0x59,0x68,0x2a,0x43,0xb0,0x33,0x81,0xe9,0x8c,0xa0,
0xa1,0xa7,0x8e,0xc0,0xe9,0x0e,0x74,0xe8,0x49,0x8c,0x40,0x92,0xbb,0xe3,0x98,0x55,
0xaa,0x28,0xc2,0xb4,0x23,0xfc,0x8a,0x40,0x00,0x00,0x00,0x29,0xa9,0x6b,0x60,0x07,
0x36,0xc3,0x54,0x77,0xb3,0x75,0x3e,0xe4,0x8b,0xe6,0xda,0x1b,0x1a,0xf1,0x0c,0x74,
0x66,0x7a,0xbc,0x6e,0xf4,0x69,0x36,0xae,0x7d,0xeb,0xb5,0x1a,0x9b,0xcb,0x47,0xda,
0x6a,0xb5,0xe8,0x5a,0x3b,0x95,0x53,0x3b,0x4d,0x5d,0xa8,0xd4,0xde,0xb9,0xf7,0xa6,
0x4a,0x34,0x1e,0x3b,0xab,0xcf,0x8c,0xc0,0x92,0x46,0x57,0x70,0x6b,0x1d,0xd4,0x92,
0x24,0x66,0x0c,0x82,0xfb,0x5a,0x39,0x09,0x21,0x52,0x62,0xab,0x1f,0x49,0x65,0x68,
0x68,0x72,0xd5,0xa3,0xd1,0x72,0x00,0x0b,0xb8,0x41,0xff,0x8b,0x26,0xd3,0xc9,0xb6,
0x87,0xc8,0x32,0xb3,0x91,0x0f,0x20,0x0e,0x06,0x1d,0xc9,0xe1,0x53,0xf5,0x5c,0xce,
0xeb,0x84,0xa8,0xaa,0x8d,0x07,0x8d,0x09,0x8a,0xa3,0xc3,0x63,0x41,0xe3,0x48,0x9e,
0xac,0x8b,0x1f,0x2a,0x17,0x30,0x2a,0x5c,0x8b,0x16,0x01,0x26,0x7d,0xca,0x63,0xab,
0x43,0x5e,0xa4,0xb1,0xd5,0x91,0x3d,0x52,0x58,0xe9,0x66,0x98,0x62,0x92,0xc8,0xe4,
0x05,0xcc,0x2f,0x48,0xb9,0xa6,0x3e,0x86,0xba,0xb4,0xbe,0xa4,0x35,0xdd,0xf5,0x23,
0xff,0xff,0xfe,0xd6,0xb4,0x1a,0x9c,0x0c,0x8b,0x90,0x26,0xd8,0xbf,0x20,0xcb,0x96,
0x15,0x3f,0x10,0xc5,0x87,0xcf,0xd9,0x3e,0x24,0x9d,0x49,0xdd,0x07,0x4d,0xfd,0x06,
0xdc,0xbc,0x68,0x7a,0x0d,0x08,0xea,0x6c,0x78,0x2a,0x0d,0x0e,0xd2,0xd0,0x78,0x2c,
0x78,0x2c,0xb5,0x6a,0xe3,0xba,0x58,0x83,0xea,0x49,0xe7,0x2d,0x0c,0x7d,0x4c,0x72,
0x8b,0xa1,0x94,0x13,0x38,0xe5,0x5f,0x5a,0x1a,0xea,0x58,0xfa,0xd0,0xea,0x92,0xc7,
0xd0,0xd7,0x54,0x97,0xd4,0x86,0xbb,0x63,0xea,0xee,0x4b,0x3a,0xd0,0xdf,0xb1,0x7d,
0xd5,0xa3,0xa5,0x8e,0x00,0xff,0xfb,0x92,0x00,0x00,0x80,0x02,0xd9,0x19,0x5d,0x91,
0xe9,0x29,0xc0,0x5c,0xc3,0xfb,0xa1,0x61,0x65,0x4a,0x0c,0x39,0x9f,0x7f,0x49,0x08,
0x6d,0xe9,0x6d,0xaf,0x31,0xb5,0x11,0x0d,0xbd,0x12,0xa1,0x92,0x08,0x69,0x4a,0x22,
0xd3,0x9b,0x5b,0x38,0x10,0xe0,0xe6,0xd1,0x0f,0x3a,0x7f,0x9e,0xf4,0x0f,0x0b,0x67,
0x11,0xa8,0xfb,0xb4,0x74,0x6b,0x46,0x51,0xae,0xd1,0x49,0x17,0xb9,0x42,0xa7,0xdc,
0xb4,0xb6,0xb5,0x92,0x74,0xb1,0x03,0x8e,0x52,0x0e,0xbd,0x6a,0x6b,0xe5,0x5a,0xda,
0x92,0x16,0x4a,0x96,0x71,0xcc,0x01,0xb1,0x8b,0x2e,0x81,0xb1,0xed,0x3e,0xf6,0xa1,
0xa9,0x51,0x44,0x0e,0x8c,0x69,0xc7,0x31,0x22,0xc8,0x59,0x78,0xd6,0x8f,0x63,0xf4,
0x6a,0xfb,0x7f,0x80,0xea,0xa2,0x55,0x25,0x55,0xb4,0xd5,0xba,0xd4,0x7b,0x24,0x7b,
0x20,0x58,0xe8,0x29,0xcc,0x4c,0xf2,0xde,0x08,0xf9,0x5d,0x5a,0xba,0xab,0xc5,0x9a,
0x19,0x1a,0xd1,0x0a,0x34,0xcd,0x1d,0x47,0x89,0xd3,0x57,0x8f,0x91,0x3e,0xf4,0x11,
0x3d,0x51,0x47,0x3a,0x55,0x8e,0x97,0x49,0xda,0xe7,0xdf,0x43,0x2a,0x28,0x81,0x91,
0x8d,0x3e,0xe5,0xa5,0xa9,0x59,0x76,0x39,0xa5,0x98,0xca,0x90,0x36,0xab,0x5e,0xc4,
0xb7,0x5a,0x47,0x55,0x61,0x81,0x64,0x75,0xdf,0xf5,0x23,0xd9,0xfa,0xfe,0xdf,0xdc,
0xe2,0x00,0x80,0x00,0x00,0x12,0x84,0xc0,0x23,0x91,0xe0,0x8b,0x10,0x91,0xdd,0x92,
0xd3,0x26,0x9b,0x54,0x78,0x15,0x47,0xab,0xcd,0x57,0x85,0xa1,0x60,0xf5,0xa6,0xba,
0xd3,0x4a,0x69,0x92,0x9a,0x79,0x77,0xd3,0xa5,0xbf,0x97,0x96,0x7e,0x5f,0xe7,0xe7,
0x9f,0x9f,0x9e,0x7d,0x3d,0x7c,0xba,0x66,0xb6,0x11,0x05,0xb1,0x68,0x22,0xc1,0x58,
0x58,0x29,0xc9,0x3c,0x14,0xb2,0x03,0x9a,0x4a,0x5d,0xba,0x25,0x22,0x7b,0x08,0x9d,
0x48,0x5b,0xc3,0x27,0xc8,0x73,0x23,0x31,0xcf,0x1c,0xcb,0x31,0x8e,0x99,0xaa,0xc1,
0x89,0x1c,0xca,0xa6,0x4d,0x28,0x16,0xd3,0x97,0x72,0xe0,0x2b,0x49,0x02,0x2c,0x4b,
0x46,0x96,0x7a,0x64,0xd4,0xaa,0xf0,0xd5,0x7a,0xe9,0x5d,0x7d,0x75,0xf5,0xcf,0x47,
0x93,0x7a,0x6d,0xbd,0xbc,0xbf,0xcb,0xcb,0xfc,0xb8,0x5b,0x79,0x73,0xcf,0xa7,0xc9,
0x7e,0xfc,0x97,0xed,0x8f,0xd2,0xde,0xc3,0x37,0xbb,0x9c,0x33,0x4f,0x33,0x23,0x32,
0x2c,0x73,0x2f,0x18,0x98,0xcc,0x4d,0x84,0x4d,0x19,0x56,0x21,0x34,0xa5,0x82,0x96,
0x4b,0xe0,0xa5,0xe0,0x3a,0x62,0xb4,0x27,0x95,0x0c,0x24,0xf2,0x97,0xd0,0x00,0x00,
0x4a,0x92,0x89,0xe8,0x01,0xdc,0x9e,0xff,0xfb,0x92,0x00,0x05,0x00,0x03,0x05,0x68,
0x5e,0xba,0x42,0x1b,0x72,0x5d,0xa3,0xbb,0xa1,0x61,0x65,0x4a,0x0b,0x34,0xa9,0x76,
0xcc,0x14,0x49,0x81,0xa4,0xb4,0x6f,0x59,0x81,0x0d,0xbd,0x1a,0xe3,0x7a,0x2e,0x19,
0xd2,0xac,0x8f,0x69,0x52,0xa3,0xa8,0x5a,0x92,0x47,0x89,0xab,0xc2,0x63,0xd5,0xe9,
0x47,0xb6,0xf4,0xd7,0x7a,0x6b,0x47,0xbf,0x97,0x7d,0xfc,0xb5,0xfb,0xdf,0x2f,0x2e,
0xf9,0x79,0xeb,0xdf,0x9e,0x5d,0x3e,0x79,0xf9,0xed,0xcc,0xc2,0x53,0x1e,0x42,0x30,
0x7b,0x1c,0x34,0xd7,0x05,0x9b,0xcc,0x6b,0x48,0xef,0x4b,0x2b,0xa9,0x83,0xc9,0x2e,
0x35,0x53,0x58,0xb0,0xd4,0xad,0x34,0x05,0x9a,0x5c,0x74,0x6d,0xa9,0x47,0xc7,0x90,
0x8c,0x10,0x0e,0xbc,0x80,0x63,0x97,0x3d,0x6a,0x71,0xec,0xb7,0xe3,0xf1,0x5c,0x53,
0x5b,0x1a,0x33,0x13,0x39,0x20,0x75,0x4b,0x3a,0x5f,0x35,0xd5,0xe2,0x18,0x6c,0x6b,
0xc6,0x50,0x7c,0xaf,0x34,0x66,0x7c,0x7c,0x64,0xb9,0x13,0xce,0x52,0x5a,0xe5,0x24,
0xfd,0x45,0x52,0xfa,0x89,0xbe,0xa6,0x9d,0x7c,0xa3,0x5e,0xc2,0x8d,0x3b,0x42,0x1b,
0x5a,0x02,0xf5,0x96,0x43,0xe3,0x88,0x0f,0x8e,0x61,0xd7,0xd2,0xc7,0xb5,0x2c,0xd2,
0x96,0x25,0x69,0x08,0x25,0x69,0xeb,0xbb,0xfb,0x74,0xb7,0xfa,0x75,0x7e,0xfb,0xe0,
0x00,0x00,0x95,0x2b,0x39,0xbc,0xd4,0xec,0x6d,0xed,0xd3,0x5e,0xf9,0x2c,0xfc,0x05,
0x1e,0x80,0x3d,0x43,0x61,0x0c,0x32,0x15,0x86,0xc6,0xe7,0x65,0x34,0x8f,0x0b,0x41,
0xe0,0xb1,0x14,0x69,0x2a,0xf5,0xcd,0x47,0x96,0x8f,0xb5,0x36,0xa6,0x3d,0x2d,0x7a,
0x84,0x27,0x5c,0xb4,0x31,0xd5,0x93,0x7d,0x68,0x08,0x98,0x16,0x2c,0xea,0x90,0xd7,
0xd6,0x86,0x38,0x62,0x02,0xc6,0xc5,0x4b,0x35,0xeb,0x2e,0xc7,0x30,0x62,0x05,0xcd,
0xe3,0xd0,0x2c,0x96,0xba,0xa4,0x37,0xff,0xdd,0x00,0x00,0x40,0x5d,0xa3,0x80,0x95,
0x5d,0xb1,0xc2,0x7d,0xfe,0xfa,0x19,0xff,0x94,0xdf,0xd5,0x3c,0x18,0xf0,0x94,0x1a,
0x0b,0x15,0x06,0xd3,0x32,0x92,0xcf,0x07,0x8f,0x05,0x8d,0x05,0xb5,0x4d,0x3b,0x4d,
0x47,0x85,0xf1,0xfa,0x5a,0x70,0xb4,0xf6,0xe9,0x6d,0xd3,0xd7,0xdf,0xa7,0xa7,0x8d,
0x01,0x64,0xd6,0x91,0xb7,0x53,0xa6,0x40,0xe6,0x3d,0x05,0x90,0xd0,0x16,0x45,0x6f,
0x4c,0x8e,0x5c,0xc8,0x1c,0xc7,0x20,0x65,0xa7,0x0a,0x26,0xe7,0x69,0x1b,0x5a,0x64,
0x16,0x62,0xca,0x9e,0x9a,0x0d,0x01,0x19,0x0a,0xb4,0x8d,0xad,0x44,0xac,0x4f,0x0c,
0xd4,0x15,0x20,0x00,0x3b,0xfa,0x36,0x24,0x85,0xff,0xfb,0x92,0x00,0x03,0x80,0x02,
0xfb,0x23,0x5d,0x2b,0x29,0x2a,0x50,0x59,0xe3,0xbb,0xb6,0x61,0x22,0x4a,0x0b,0xac,
0x73,0x74,0xac,0x24,0xa9,0x41,0xa1,0xb2,0x6f,0x69,0x82,0x8d,0xb9,0x27,0xe2,0xbd,
0x61,0xbd,0x99,0x73,0xe4,0x0e,0x4a,0xc5,0x5e,0xc5,0xec,0x8e,0xd2,0x8f,0x59,0xdc,
0xc7,0x4f,0x22,0x2f,0x0c,0x8c,0x78,0x96,0x3e,0x26,0x54,0x5a,0x34,0xe8,0xa9,0x57,
0x8e,0xa3,0xcd,0x8f,0x75,0x24,0x0f,0xd0,0x4d,0x8f,0x5a,0x1a,0xe5,0xa5,0x95,0x20,
0x9b,0x2a,0x43,0x5c,0xb3,0x6c,0xa8,0xd1,0x35,0xac,0x00,0x86,0xd6,0x83,0xb5,0x1b,
0x6d,0x66,0x09,0x6b,0x41,0xda,0x92,0x7a,0x2e,0x63,0x60,0xf4,0x3e,0xa4,0xeb,0x47,
0xf5,0x75,0xf5,0x7f,0xee,0xe4,0x00,0x00,0x0a,0xa3,0x23,0xf4,0x90,0xaa,0x9c,0x57,
0xad,0x67,0xb5,0x5f,0x3d,0x07,0x1a,0xb2,0x2f,0x67,0xed,0x1f,0x4a,0x7d,0x6c,0xee,
0xe9,0xe4,0x2e,0x35,0x1e,0x0a,0xa3,0xce,0xd3,0xd1,0xaf,0x56,0x83,0x95,0x6b,0x9e,
0xb6,0x1f,0x74,0xb3,0x1f,0x2a,0xd7,0x50,0xd3,0xfa,0x18,0xfa,0x58,0xe5,0x98,0x26,
0x2f,0x03,0x90,0x15,0x7a,0x8d,0x9d,0xac,0xc1,0x35,0x8a,0x01,0xd0,0x7a,0xa4,0x9d,
0x8b,0x98,0x74,0x58,0x0e,0x87,0x31,0x44,0x9e,0x91,0x54,0x39,0x02,0xeb,0xfb,0xe0,
0x00,0x0e,0x87,0xc0,0xd7,0xd3,0x25,0x2c,0x2f,0x8c,0xab,0xea,0x3d,0xd4,0x22,0x63,
0x84,0x72,0xc5,0xec,0xc6,0xd0,0xff,0x5d,0xdd,0x1f,0x4f,0x21,0x54,0x58,0xc6,0x88,
0xd4,0x7c,0xaf,0x1f,0xb5,0xb1,0xc7,0x16,0x5c,0x8b,0xde,0x84,0x1e,0x72,0x8a,0xb2,
0xb5,0xb5,0xf5,0x11,0x73,0xa9,0x7b,0xd6,0x86,0x54,0x35,0xa7,0x2b,0x24,0x31,0xf4,
0x3d,0xcd,0x2a,0xda,0xc7,0x31,0x95,0x20,0xfb,0xda,0x97,0x3a,0x86,0x63,0x5a,0xd4,
0x29,0x27,0x1c,0xd4,0x5f,0xf5,0x75,0xfa,0x2e,0xfa,0xfa,0xbf,0x7e,0x60,0x00,0x00,
0x00,0x1a,0x96,0x8e,0x88,0x0b,0x5c,0x98,0xcb,0xcf,0x83,0xed,0xf7,0x24,0x5f,0x35,
0xcf,0x9d,0xa8,0xf8,0xec,0x36,0x76,0x8b,0xd5,0xa2,0x14,0x3c,0x66,0xb5,0xd7,0x35,
0x1a,0x5d,0xb7,0xbe,0xf3,0xf9,0x73,0xe7,0x3e,0xf1,0x70,0x66,0x4d,0xc1,0xf6,0x2c,
0x6b,0x9e,0x5e,0x7d,0x2d,0xfa,0x5c,0xff,0x99,0x83,0xe9,0x90,0x5a,0x4d,0x21,0x6b,
0x31,0xa9,0x3e,0x3c,0x83,0x9b,0xc5,0x10,0xa0,0xb2,0x08,0x40,0xb3,0x07,0x59,0x5c,
0x1b,0x93,0x48,0x3a,0x32,0x63,0x5c,0x7a,0x57,0x1d,0x9d,0x09,0xda,0x91,0x04,0xda,
0x90,0x2c,0xaa,0xf5,0x23,0x6f,0xc0,0x80,0x00,0x41,0x4d,0xff,0xfb,0x92,0x00,0x03,
0x00,0x03,0x13,0x64,0xe0,0xd1,0xe2,0x1b,0x7a,0x5a,0xc3,0xbb,0xb2,0x61,0x22,0x4a,
0x0a,0xbc,0x41,0x76,0xcc,0x24,0x47,0x09,0xa8,0x32,0xf0,0x35,0x31,0x0d,0xbd,0xd6,
0xf0,0x29,0x39,0x9d,0xa6,0xbe,0x8b,0xaf,0x5e,0x85,0xe1,0xeb,0xc7,0xde,0x2a,0xaf,
0x5d,0x2a,0xd3,0xef,0x46,0x9a,0xba,0x6d,0xb5,0xf6,0xa6,0x94,0xc9,0xe5,0xe7,0xaf,
0x3e,0x79,0xf0,0xf2,0xf3,0xef,0xde,0x1e,0xf9,0x8f,0x91,0x93,0x5a,0x78,0x3e,0x3d,
0xa4,0x63,0xf4,0x72,0x6b,0x5a,0x83,0xf7,0xd4,0x63,0x32,0x31,0x56,0x16,0x0a,0xd2,
0xb7,0x21,0xbc,0x8d,0xb4,0x58,0x0b,0xd2,0xd3,0x22,0x32,0x1a,0x42,0x20,0x72,0x58,
0x09,0xc8,0x59,0x66,0x4b,0x11,0x68,0x38,0x7a,0x95,0x46,0xe0,0x00,0x55,0x01,0x86,
0xaa,0x7d,0x9e,0xb9,0xfc,0x6e,0x3f,0x24,0xb9,0x62,0x37,0x48,0x7f,0xf3,0xfd,0x17,
0x4d,0xab,0x3b,0xfa,0x9e,0xdd,0x76,0x71,0x50,0x4d,0x05,0x56,0x91,0xe3,0x51,0xa6,
0xa3,0x41,0x4a,0x11,0x65,0x44,0x5e,0xe5,0x94,0x6b,0xd6,0x55,0x0f,0xad,0xad,0xad,
0x2e,0x7a,0x96,0xd7,0x28,0x0a,0x93,0x8c,0x53,0x02,0xc6,0x06,0x20,0xe1,0xa1,0x65,
0x0a,0x39,0x66,0x90,0x72,0xb6,0x84,0x4c,0x0f,0x4b,0x5c,0x2e,0xb6,0xbe,0x65,0x27,
0xda,0xb4,0x05,0x8d,0xd1,0xf7,0x20,0x00,0x04,0x2a,0x6e,0x20,0xf0,0x45,0x63,0xac,
0x7f,0x4d,0xdb,0xce,0x04,0x39,0x0b,0xec,0xa7,0xa3,0xf6,0x43,0xec,0x44,0xa3,0xc2,
0xd4,0x6e,0x23,0x1f,0xcc,0x66,0xbf,0x31,0x98,0xd7,0x7d,0x46,0xbb,0xbd,0x12,0xfe,
0xe5,0xa3,0xff,0xba,0xbb,0xbb,0xab,0xbb,0xf9,0x77,0x7f,0x36,0xef,0xee,0xec,0xad,
0x6b,0xd9,0xf7,0x43,0x66,0x7d,0x89,0x19,0xdf,0x26,0x27,0xba,0x37,0x75,0xa8,0x5e,
0xee,0xb3,0x76,0x6b,0xfb,0xa6,0x35,0xdd,0x5f,0x55,0xea,0xef,0x70,0x80,0x00,0x00,
0x00,0x09,0x46,0x4a,0x26,0xd0,0x0b,0x80,0xed,0x1f,0x23,0x7e,0x47,0x4e,0x15,0x26,
0x2f,0x43,0x1e,0x16,0xad,0x57,0xae,0xd2,0xe4,0xda,0xb5,0x6a,0x6b,0xb5,0x68,0xf4,
0x6a,0xef,0x37,0x1f,0xcf,0x9c,0x3d,0xba,0x9e,0x7b,0x70,0xb5,0x3e,0x70,0xf5,0xe9,
0x79,0xeb,0xd2,0xd7,0xe7,0x89,0x20,0x1c,0x38,0xcc,0xca,0x80,0xd6,0x89,0xc0,0x68,
0x43,0x53,0x54,0x0a,0x40,0x87,0xa2,0xaa,0x55,0x76,0xa0,0x46,0x08,0xd5,0x95,0xe3,
0x46,0xc5,0x61,0x36,0x26,0x76,0x38,0xc6,0x26,0x3c,0x64,0x63,0x52,0x06,0x4c,0x51,
0xd9,0x6a,0xe2,0x40,0xc9,0x15,0x4f,0xe3,0x12,0x6a,0x3c,0x0a,0xd5,0xff,0xfb,0x92,
0x00,0x03,0x80,0x03,0x12,0x24,0x5c,0x83,0x0b,0x2a,0x50,0x62,0x2c,0x9c,0x0d,0x3c,
0x42,0x6e,0x4b,0xbd,0x93,0x7e,0xe8,0x88,0x6d,0xe9,0x7f,0x12,0x6e,0x41,0x96,0x15,
0x28,0xb5,0x1b,0xfe,0xb5,0x1c,0x58,0x7a,0x07,0x4e,0xa1,0x1f,0x22,0x70,0x42,0xe5,
0x17,0x9b,0x72,0x65,0x0a,0xc1,0x63,0x5a,0x1e,0xa8,0xe8,0xdc,0x7c,0x6b,0x44,0xa8,
0x3e,0x37,0x1f,0x47,0x97,0x1f,0x1b,0x51,0x13,0xb5,0x21,0x8e,0x52,0x18,0xea,0xc9,
0x3a,0xb4,0xb6,0xa2,0x6d,0x7d,0x47,0xde,0xb2,0xe8,0xd2,0x40,0xe7,0x75,0x48,0xd4,
0x86,0xbf,0x63,0xeb,0x4e,0xb4,0xb5,0xd4,0xb5,0xd5,0x5f,0x52,0x19,0x62,0x18,0xe8,
0xe8,0xca,0xd3,0x43,0x52,0xd7,0xb5,0xf1,0xf5,0x56,0x9a,0x19,0xd4,0x24,0x00,0x00,
0x00,0x12,0x52,0xbb,0x15,0x40,0x24,0xb0,0x1d,0x87,0xdf,0x49,0xfe,0xeb,0xc0,0xdf,
0xae,0x3c,0x16,0x35,0x1e,0x6d,0xa9,0xb5,0x5a,0x9b,0x57,0x7a,0xb5,0x37,0xae,0xfb,
0xd7,0x7a,0xeb,0xbd,0x76,0xa3,0xd7,0x6a,0x6d,0x47,0xa6,0xd4,0xdf,0x6a,0x6d,0x56,
0x63,0x22,0xb3,0x03,0xc7,0x45,0x66,0x32,0xc7,0x70,0x76,0x74,0x47,0x70,0xab,0x1d,
0xc1,0xdc,0x4a,0xa3,0xb8,0x35,0x8c,0x50,0x57,0x2a,0xa3,0x30,0x24,0x8c,0xa0,0x9d,
0x8c,0x91,0x98,0x12,0x38,0xe8,0xac,0xc6,0x48,0xc6,0x06,0xb4,0xab,0x42,0xec,0x00,
0x00,0x01,0x09,0x43,0xe0,0xca,0x56,0x16,0x81,0xe9,0x88,0xc9,0xd3,0x59,0x93,0x4b,
0x74,0x1e,0x1e,0x8b,0x04,0xd2,0xed,0x3d,0x0f,0x07,0x97,0x69,0x32,0x57,0x5d,0xf7,
0xb5,0x34,0xe9,0xf9,0x67,0xc3,0xe7,0x17,0x85,0x9f,0x0b,0xbf,0x79,0xeb,0xe5,0xd2,
0xd3,0xbf,0x7c,0xbc,0xc9,0x2d,0x2a,0x0b,0xdb,0xcc,0x93,0x87,0x01,0x7b,0x58,0x46,
0x79,0x8f,0x01,0x7d,0x90,0x8d,0xb2,0x1b,0xa4,0x76,0x43,0x55,0x32,0x18,0xe9,0x22,
0x5b,0x28,0x3c,0x85,0x79,0x92,0x55,0x48,0x0a,0x9c,0x3e,0xaa,0xa4,0x45,0x2d,0x42,
0x94,0x51,0x8f,0x71,0x7c,0x7c,0x17,0x15,0xc1,0xe9,0xcb,0x8c,0xbe,0x04,0x1d,0x33,
0xe8,0x1b,0xc2,0x97,0x79,0xec,0xe2,0x28,0xbb,0x20,0xba,0x85,0xb4,0x46,0x83,0xa5,
0x76,0x14,0x8d,0x68,0xda,0x9a,0x57,0x61,0xd4,0x79,0x2a,0x8a,0x35,0x8f,0x56,0x50,
0xfb,0xa5,0x98,0xd5,0x2c,0x8b,0xdc,0xa2,0x0c,0xa9,0x37,0xca,0xb0,0xe5,0x49,0x7d,
0x76,0x3a,0x8e,0xb6,0xbb,0x43,0x6a,0xdd,0x4b,0x35,0x25,0xfd,0x95,0x22,0xfa,0x9b,
0xbd,0x0e,0xae,0x2e,0xea,0x36,0xae,0xfb,0xba,0xb3,0x7b,0x2c,0x62,0x83,0x40,0xff,
0xfb,0x92,0x00,0x01,0x80,0x02,0xe9,0x63,0xe3,0x7a,0x01,0x1b,0x7a,0x59,0x4b,0xbc,
0x6d,0x40,0x42,0x6f,0x4a,0xe8,0x63,0x76,0xcc,0x30,0xa7,0x01,0xa5,0xb4,0x6f,0xa9,
0x81,0x0d,0xbd,0x01,0x20,0x14,0x93,0x6d,0xdd,0xc3,0x51,0x03,0x24,0x47,0xe1,0xdc,
0x89,0x0f,0x96,0x4d,0xeb,0xda,0x4e,0x0d,0xfb,0xd5,0x6e,0x6e,0x29,0x29,0x79,0xe5,
0x3c,0xb3,0x96,0x7e,0x5c,0xf2,0xf3,0xcf,0xcf,0xcb,0x2f,0x2e,0xf9,0xf0,0xb6,0xe7,
0xdf,0xbd,0xf9,0xff,0x0c,0x9e,0xd2,0xde,0xe3,0x48,0x79,0xcc,0x7a,0x6b,0x94,0x84,
0x4b,0x1c,0x77,0x86,0x6d,0x61,0x10,0x3d,0x29,0x03,0xce,0x73,0x30,0x50,0x9e,0xd2,
0x27,0xb4,0x68,0x8d,0x8d,0x33,0xce,0xe3,0x59,0x08,0xab,0x5a,0x2f,0xe5,0xe5,0x00,
0x40,0x52,0x4d,0x39,0x77,0x0d,0x44,0x0c,0x91,0x1f,0x87,0xa5,0x8e,0xb9,0x64,0xaf,
0x5e,0xdb,0xc4,0x6f,0xef,0xb4,0xbb,0xd7,0x4a,0x69,0xeb,0xa6,0xd4,0xdf,0x7b,0xed,
0xed,0xbd,0x37,0xa6,0xb5,0xd7,0x4a,0x3b,0x92,0x8f,0x56,0x9f,0x6b,0x6f,0xbc,0xca,
0x8d,0x36,0x5a,0xbb,0xa5,0x6e,0x0a,0xc7,0x82,0x76,0x0e,0xaa,0x32,0x21,0x62,0x12,
0x3a,0xba,0xc7,0x54,0x69,0x52,0x33,0x16,0xe6,0x74,0x67,0x05,0x25,0x81,0xdf,0x39,
0x8a,0x69,0xa1,0x44,0xf6,0xc3,0x64,0x00,0x00,0x0a,0x9b,0xa0,0x3c,0x33,0x8a,0xcd,
0x02,0x75,0xc0,0xf6,0x46,0xfe,0x55,0x7f,0x10,0xe5,0x09,0x1c,0xaa,0xed,0x16,0x85,
0xb4,0x52,0x83,0xa2,0x55,0x25,0x9e,0x5a,0x67,0xc7,0xbd,0x69,0x61,0xe5,0x16,0x22,
0xca,0x90,0x7e,0xb4,0xb9,0xea,0x59,0x27,0x54,0x41,0xf5,0xcf,0x3f,0x6b,0xa5,0x18,
0x11,0xa4,0x88,0xb3,0xd6,0x96,0xd4,0x60,0x93,0xc5,0xc0,0x68,0x74,0x5c,0x9b,0xcd,
0x0a,0x2c,0xf1,0x96,0xa9,0x8e,0x41,0x76,0x8f,0x4c,0x90,0xab,0xe8,0x62,0x60,0x00,
0x00,0x00,0x00,0x4a,0x3d,0x01,0x15,0xb0,0xd8,0xa0,0x4e,0xc3,0x1f,0xb9,0x3f,0x66,
0x7b,0xaa,0xf4,0x1e,0x2a,0xa6,0x83,0x68,0xd4,0x68,0x2a,0x88,0xab,0xcb,0x47,0xbb,
0x4d,0x5c,0xfb,0x53,0x4d,0xe5,0xe5,0xe7,0x9f,0x4f,0xbe,0x5c,0x2e,0x74,0xf2,0xf5,
0xe7,0xbf,0x9f,0x7d,0x3c,0x89,0xbb,0x38,0x66,0x26,0xc2,0xc3,0xdc,0x73,0xa7,0x83,
0x94,0x62,0x32,0x26,0x80,0x8c,0xd3,0x83,0x28,0x27,0xdf,0xc7,0x30,0xb6,0xc4,0xa4,
0x4d,0x29,0x50,0x8c,0x63,0x28,0x64,0x60,0x76,0x0e,0x6a,0xe6,0xd0,0x19,0x11,0xea,
0x29,0x41,0x43,0x42,0x31,0x88,0x1d,0x00,0x63,0xf7,0xd8,0x3b,0xf2,0xe6,0xc8,0xf6,
0x6d,0xff,0xfb,0x92,0x00,0x05,0x00,0x02,0xc8,0x42,0x5e,0x13,0x05,0x12,0xe2,0x68,
0xad,0x1b,0xc7,0x60,0xa3,0x6e,0x4c,0x71,0xa3,0x81,0x48,0x88,0x6d,0xe9,0x77,0x8e,
0xee,0x95,0x84,0x89,0x28,0xdb,0xfa,0x90,0xaf,0x8e,0x3a,0x81,0xa3,0x07,0xa8,0x76,
0xa2,0x91,0x17,0x9e,0x83,0xa2,0x74,0x15,0x8c,0x79,0xa8,0xf2,0xe4,0xab,0xc9,0xb5,
0x72,0xd1,0xe6,0xa1,0xe8,0xf2,0x55,0xe9,0x8d,0x06,0xd2,0xd7,0x33,0x39,0xd1,0x1a,
0x9b,0xd3,0x6a,0xff,0xb3,0x9d,0x23,0x38,0x2c,0x78,0x2f,0xee,0xe6,0xa9,0x5b,0x37,
0xae,0x6e,0xee,0xf6,0x9d,0xba,0x95,0xb3,0x76,0x67,0x75,0xa9,0xf6,0x76,0xea,0xd5,
0xd7,0xb3,0x3b,0xa7,0x20,0x00,0x00,0x01,0x92,0xbe,0xc1,0xe3,0x9e,0x6a,0x8e,0x66,
0xdc,0xbf,0xa9,0x0a,0xf9,0x8b,0xfb,0x97,0x46,0x0f,0x50,0x8d,0x45,0x23,0x5e,0x2f,
0x18,0xd3,0xd0,0xb4,0x79,0xa8,0xf1,0xbb,0x55,0xe4,0xa3,0x55,0xa5,0xde,0x9e,0x7c,
0xf2,0xef,0x97,0xfe,0x5d,0xf3,0xe7,0x9f,0x3c,0xbb,0xf9,0xf7,0xcb,0xbe,0x5c,0xcc,
0x78,0x0b,0x62,0x35,0x97,0x32,0x05,0x08,0x67,0x07,0x90,0xd4,0x16,0x6d,0xb3,0xc3,
0x32,0x4b,0x47,0x20,0x54,0x86,0x30,0x7e,0xbd,0x36,0x62,0x67,0x90,0x90,0x25,0xa3,
0x90,0x47,0x31,0x38,0x32,0xab,0xaa,0x48,0x46,0xf2,0x0c,0x61,0x2f,0xa8,0x00,0x00,
0x00,0x08,0x6e,0x87,0x74,0x07,0xc3,0xa3,0xa8,0x6f,0x48,0x24,0xe2,0xa6,0x4d,0x3d,
0x04,0xf0,0xd8,0xd4,0x7a,0x51,0xad,0xbd,0x32,0xef,0x4c,0xbb,0xcf,0x4d,0x77,0xa6,
0xbe,0x7d,0xfb,0xd3,0xcf,0xcf,0xbe,0xdd,0x3e,0xfb,0x79,0x6f,0xdf,0x9e,0x7d,0xf9,
0xe5,0xd2,0x30,0x5a,0x0d,0x0d,0x6a,0x18,0x22,0x21,0x36,0x8c,0xc0,0xb2,0x59,0x94,
0x4d,0x29,0x2a,0xe2,0x24,0x32,0x0b,0x31,0xa4,0x32,0xb1,0xc6,0x84,0xc8,0xe4,0x0c,
0xc8,0x4c,0x83,0xa8,0x3c,0xc4,0xcc,0x75,0x0f,0xbc,0x45,0x6c,0x5d,0x06,0x46,0x16,
0x60,0x00,0x1d,0x0e,0xa1,0x77,0x50,0xb7,0x25,0x38,0xc9,0x96,0x76,0x08,0xb9,0xc1,
0x67,0x70,0xe6,0x1c,0x3f,0xc6,0xbc,0x0c,0xf8,0x3f,0x10,0x74,0xb2,0x25,0xe3,0xc1,
0x3c,0x2e,0x3c,0x8e,0x8b,0x57,0xbd,0x1e,0x0e,0xb2,0x2f,0x79,0x66,0x9f,0x7c,0xb3,
0x5e,0xa4,0x37,0x28,0x86,0xd4,0x83,0xd5,0x22,0xe5,0x28,0x88,0xc8,0xc2,0x2f,0x72,
0xad,0x73,0x0a,0xb5,0xec,0x4b,0x5b,0x5a,0x5a,0x6d,0x69,0x17,0x4a,0x8b,0xa5,0xd5,
0xa4,0x74,0x6d,0xce,0xd8,0xed,0x8e,0xfd,0x2c,0xd3,0xfd,0x7f,0xfb,0xef,0x01,0xe3,
0x03,0x62,0xc1,0xff,0xfb,0x92,0x00,0x02,0x80,0x02,0xd5,0x1d,0x5d,0x0b,0x29,0x12,
0x50,0x63,0x0d,0x1b,0xfa,0x48,0x43,0x6f,0x4c,0x39,0x93,0x83,0xa9,0x84,0x6d,0xe9,
0x5a,0x8f,0x2e,0xc9,0x84,0x89,0x28,0xcf,0xba,0x9c,0x7b,0x4f,0xf9,0x23,0xd9,0x11,
0x1b,0x34,0x2b,0xd0,0xf3,0xec,0x6e,0xd2,0x9f,0x39,0x5d,0x5e,0x96,0x43,0x22,0x8a,
0x82,0x68,0xaa,0x8f,0x76,0x8f,0xbc,0x94,0x1e,0x21,0x38,0xe5,0xa0,0xd3,0xe8,0x4b,
0xeb,0x26,0x76,0xbb,0x2a,0x53,0x1f,0x28,0x49,0xfa,0x5e,0x6a,0x93,0xae,0x51,0x66,
0x29,0x4b,0x60,0xad,0x68,0x3e,0xe5,0x98,0xba,0x61,0x2e,0x96,0x26,0x7a,0x2f,0x6c,
0x5d,0x4c,0xd4,0xc7,0x22,0x97,0xe9,0xf6,0x6a,0x66,0xaf,0xfd,0xdb,0x80,0x00,0x00,
0x00,0x08,0x4e,0x17,0x01,0x59,0x21,0x07,0x2c,0x84,0x91,0x39,0xc2,0xa4,0xcd,0xa6,
0xf0,0x4f,0x0f,0x43,0xc1,0x6b,0x4c,0x15,0x4d,0x46,0x9a,0xaf,0x36,0xfb,0xdb,0x7d,
0xed,0xbc,0x9e,0x5d,0xf4,0xe9,0x77,0xb3,0xbf,0x78,0x7d,0xf5,0xe1,0x6b,0xe5,0xc2,
0xcb,0xcb,0x3f,0x3f,0x22,0x17,0xc1,0xcd,0xd7,0x77,0x86,0x69,0x61,0xe0,0xa7,0x20,
0x2f,0x05,0x2b,0x30,0x34,0x26,0x94,0xcd,0x69,0x0e,0x74,0xcc,0x4f,0x8e,0x64,0x66,
0x31,0x52,0x34,0x94,0x64,0xaa,0x48,0x94,0x88,0x1d,0x96,0x03,0xbd,0xb3,0xa0,0xec,
0x45,0x00,0x00,0x00,0x02,0x49,0x2e,0x50,0xe2,0x80,0xe2,0x53,0x61,0x7e,0x4b,0x47,
0x66,0x5a,0x98,0xbd,0x29,0x38,0x37,0x25,0x14,0xb3,0xd6,0xaa,0x6e,0x78,0x24,0xef,
0x72,0xce,0x4e,0x3f,0x2e,0x96,0xbd,0xf9,0xe5,0xe7,0xb7,0x0f,0x9e,0x7e,0x59,0xf9,
0x77,0xef,0x4b,0x2f,0x3e,0x99,0x06,0xe1,0x9a,0x53,0x1e,0x42,0x35,0xe6,0x60,0xf2,
0x4b,0x8d,0x56,0xd1,0x48,0x08,0xc9,0x2c,0x1e,0x1a,0x62,0xa0,0x22,0x30,0x7a,0x9b,
0x3a,0x63,0x5a,0xee,0x17,0x5c,0x81,0x39,0x88,0xb8,0xf1,0xa3,0x29,0x02,0xcb,0xaa,
0xcb,0x40,0x00,0x54,0xbe,0x80,0xcf,0xa6,0x63,0x6d,0x9b,0xdb,0xcf,0xeb,0xe5,0x60,
0xee,0xd9,0xce,0x71,0xfd,0x07,0xe7,0xfa,0xd9,0xd6,0xe9,0x6c,0x3e,0x35,0x1a,0x5a,
0xe1,0xf1,0x1b,0xcd,0x57,0x82,0x9f,0xad,0x6c,0x7d,0x24,0x99,0x52,0x5c,0xea,0x1a,
0xe5,0x22,0xfa,0xd8,0xfd,0x27,0x12,0xb2,0xa7,0x9c,0xd2,0xed,0x42,0x8a,0xa0,0x7c,
0x6b,0x18,0xf1,0x64,0x0a,0x39,0x63,0x9a,0x31,0xa9,0x24,0xd4,0x29,0x23,0x5e,0xa0,
0x0b,0x4d,0xb1,0x08,0x1d,0x5f,0xa7,0xee,0x26,0x10,0x00,0x00,0x00,0x49,0x45,0x28,
0x7b,0x80,0x54,0xfc,0xb3,0xff,0xfb,0x92,0x00,0x06,0x80,0x03,0x38,0x68,0xdf,0xe9,
0xe2,0x1b,0x7a,0x58,0xc9,0xdb,0xda,0x3c,0xa2,0x5e,0x4c,0xbd,0x9f,0x7b,0xac,0x14,
0x4d,0xc9,0x6d,0xb4,0x71,0xb5,0x10,0x8d,0xbd,0x3c,0x70,0x97,0xf2,0xc5,0xf0,0x37,
0xe2,0xc1,0x63,0xd4,0xd5,0x69,0x69,0x92,0x85,0xab,0x4d,0x5c,0x8f,0x2d,0x1e,0xd5,
0xce,0xd3,0x51,0xed,0xcb,0xc2,0xdb,0xa5,0x9f,0x16,0x43,0x25,0x93,0xcc,0x8d,0xad,
0x22,0x5e,0x1e,0x46,0x4d,0x69,0x1b,0x76,0x79,0x92,0xc8,0x64,0xcb,0x65,0xa4,0x6d,
0x21,0x92,0x99,0x59,0x48,0xda,0xd2,0x33,0x32,0xb2,0x19,0x2c,0xa9,0xe4,0x72,0xd1,
0xc9,0x5b,0x74,0xcc,0xc1,0x5a,0x31,0xb2,0x9b,0xa6,0x3a,0x85,0x90,0x73,0x8a,0x69,
0x72,0x60,0x73,0x0c,0x00,0x00,0x00,0x01,0x0e,0x43,0xdc,0x02,0xa7,0xe5,0x99,0xe3,
0x84,0xdf,0x6f,0x71,0xc3,0x00,0xf6,0x02,0xc2,0x9e,0x3e,0xa6,0x9d,0xa2,0xb4,0x7b,
0x51,0x6a,0xd3,0x55,0xad,0xad,0x1e,0x5a,0xb6,0xd4,0xde,0xbb,0xed,0x4d,0xa9,0xbe,
0xf5,0xda,0x9b,0x6d,0x5d,0xeb,0xf6,0xa6,0xd5,0xcf,0x57,0x54,0xb3,0x53,0x25,0x5d,
0x56,0xef,0x46,0x92,0x46,0x40,0x57,0x1d,0x76,0x3e,0xcc,0x6a,0x85,0x1b,0xcc,0xb2,
0xf4,0x31,0xa5,0x2a,0x4b,0x35,0x6b,0xa9,0x29,0x15,0x2a,0x6c,0x08,0x00,0x00,0x00,
0x00,0x00,0x99,0x6c,0x64,0x6b,0x13,0xac,0x6d,0xd7,0xca,0x13,0xf4,0x36,0xfe,0x6b,
0x9f,0x3f,0x0a,0xc5,0x6a,0x29,0x1a,0xf1,0xf4,0x79,0xb1,0xf1,0xbb,0x55,0xa9,0xbd,
0x33,0x6d,0x5d,0xa8,0xf4,0xde,0x9b,0x6d,0x5d,0xe9,0x9a,0x8d,0x5d,0xaa,0xd4,0xde,
0x9b,0x6d,0x5d,0xa8,0x69,0xa8,0x3b,0x83,0x58,0xcc,0xad,0x0b,0x8e,0xe0,0x92,0x6a,
0x8c,0xc0,0xd6,0x33,0x07,0x49,0x92,0x3b,0x82,0x48,0x96,0x52,0xc2,0xac,0x77,0x04,
0x93,0x3a,0x3b,0x03,0x58,0xcc,0x72,0xcc,0x91,0xdc,0x12,0x29,0x99,0x4a,0xca,0xb1,
0x99,0x04,0x5e,0x20,0x01,0x08,0x14,0x93,0x97,0x72,0x64,0x15,0x8c,0x4a,0x93,0xe9,
0x11,0x19,0xd4,0xea,0xde,0x58,0x75,0x3d,0xc9,0xcb,0x73,0xfa,0x96,0xe5,0x96,0xa7,
0xf7,0x2f,0x3e,0x7d,0xf2,0xef,0x9f,0x9f,0x3c,0xbb,0xf7,0xcb,0x49,0x4c,0xf3,0xed,
0x84,0x4f,0x65,0xf3,0x34,0x94,0xcc,0xd6,0x3d,0x84,0x4f,0x2f,0xa9,0x9a,0x40,0x44,
0x47,0x63,0xd8,0x66,0x22,0x5c,0xd7,0x27,0xa0,0x88,0x8e,0xc2,0x8b,0x98,0xc9,0x72,
0x6d,0x0e,0x82,0x84,0x32,0x52,0xd7,0x31,0x9e,0x4d,0xb8,0x74,0x1d,0x85,0x00,0x00,
0x00,0x00,0x29,0xc1,0x94,0x08,0x7b,0xff,0xfb,0x92,0x00,0x05,0x00,0x03,0x2a,0x64,
0xdf,0xd1,0xe2,0x1b,0x7a,0x5a,0x22,0xdb,0xb9,0x61,0x65,0x38,0x0b,0x80,0x77,0x74,
0x2c,0x24,0xa9,0x41,0x6e,0x95,0x6e,0x85,0x85,0x89,0x30,0x1e,0xa9,0x7e,0x85,0x7c,
0xb4,0xf8,0x7a,0xf0,0x20,0xb0,0xd4,0x1b,0x79,0x28,0xf0,0x75,0x35,0x5e,0xfb,0x4f,
0x92,0x99,0x76,0xde,0xf4,0x7a,0xf4,0xf8,0x79,0xf9,0x69,0xff,0x3d,0x7c,0xbf,0xcf,
0xa4,0x60,0xfa,0x7c,0x2c,0x79,0x4b,0x4e,0x5e,0x11,0xad,0xc7,0xd1,0xf7,0x30,0x64,
0x40,0xba,0x71,0x93,0x1a,0xd1,0x88,0x26,0xd4,0xc1,0xa1,0x89,0xb8,0xf1,0xe3,0x0b,
0x30,0x79,0x06,0x90,0x74,0x64,0xc6,0xb0,0xc8,0x26,0xd9,0x83,0xa4,0x26,0xe3,0xc7,
0x8a,0x46,0x0f,0x24,0xa1,0x36,0xa0,0x00,0x00,0x00,0x02,0xa2,0x11,0x0c,0xde,0xb2,
0x8e,0xbd,0xfc,0x71,0xbd,0x10,0xee,0x4b,0x5a,0x47,0x66,0x44,0xbc,0xab,0x80,0x59,
0x47,0xc3,0x15,0x07,0xc4,0xea,0x91,0xaf,0x36,0x3a,0x26,0x38,0xe5,0xa4,0x83,0xd6,
0xb6,0x9f,0x7d,0x07,0xaa,0x53,0x1c,0xb4,0x92,0x7d,0x6c,0x3f,0x52,0x1c,0xe5,0x29,
0xae,0x59,0x74,0x8d,0x8e,0x63,0x1e,0x28,0x81,0xee,0x15,0x01,0xb4,0xca,0xcb,0xa4,
0x65,0x64,0x18,0x69,0x48,0x1e,0xf6,0x80,0xda,0x88,0xe2,0x43,0x34,0x31,0x2b,0x45,
0xe0,0x3b,0xee,0x1f,0xe9,0x1b,0xea,0xa7,0x3c,0x65,0xbf,0x51,0xee,0xb0,0x75,0xba,
0x21,0xa0,0xf6,0x71,0xbe,0x94,0xe8,0xe6,0xf4,0x7d,0x27,0xc5,0x1d,0x83,0x2c,0x3e,
0x3a,0x83,0xa5,0x78,0xac,0x63,0x44,0xa9,0x8c,0x94,0x22,0x72,0xa2,0x6c,0xa9,0x6c,
0x72,0x8b,0x12,0x75,0x09,0x73,0xd4,0x96,0x54,0xb6,0xc5,0x4b,0x13,0x74,0x0a,0x97,
0xbe,0x93,0xef,0x51,0x76,0xc5,0x56,0xd3,0xb5,0xa5,0xe6,0x29,0x98,0x97,0x6d,0x8b,
0x68,0xa5,0x49,0x63,0xa9,0xbb,0xea,0xea,0xb3,0xdd,0xdd,0xfd,0x80,0xbb,0xee,0x1b,
0xe9,0x1b,0xa2,0xb8,0xf8,0xcb,0x7e,0x61,0xee,0x91,0x6b,0xe0,0x93,0x04,0x4f,0x20,
0xf5,0x0f,0xc1,0x45,0xe5,0xfc,0x2f,0xad,0x74,0x65,0xa8,0xf1,0x34,0x68,0x3a,0x16,
0x0b,0x05,0x47,0xa3,0xc9,0x47,0xb6,0x36,0xf2,0xd1,0xa9,0x42,0xa0,0x2a,0x09,0x9c,
0x94,0x24,0xca,0x98,0xc7,0x29,0x17,0x4c,0x92,0x39,0x53,0x05,0xea,0x40,0xbb,0x94,
0x84,0x9b,0x99,0x24,0xfa,0x98,0x2f,0x55,0xaf,0xa1,0x26,0xe6,0x52,0xfa,0xe2,0xf1,
0x6b,0x7d,0xfa,0x75,0xdb,0xfe,0xff,0xed,0x40,0x00,0x3a,0xf9,0x01,0x92,0x2b,0x00,
0x29,0xcf,0xb3,0xaf,0x8e,0x56,0x84,0x04,0x94,0xff,0xfb,0x92,0x00,0x08,0x80,0x02,
0xf5,0x24,0x5d,0x2b,0x07,0x12,0x50,0x68,0x6d,0x1b,0xda,0x48,0xa3,0x6e,0x4a,0x88,
0x73,0x76,0x4c,0x24,0x49,0x41,0x9b,0x2f,0xaf,0x58,0xf2,0x8d,0xbd,0x12,0x71,0x03,
0x44,0x4c,0x3e,0x2a,0x66,0x1c,0xa1,0x78,0x66,0x42,0xc1,0x3c,0x7a,0x34,0x26,0x3d,
0x1a,0x0e,0x83,0xcc,0xd2,0xd1,0xef,0x46,0x83,0x97,0x63,0xe5,0xd8,0x75,0xf2,0xec,
0x7c,0xbb,0x1f,0x4b,0x0e,0xe4,0x98,0xf6,0xa5,0x8f,0x17,0x43,0x1f,0x41,0x26,0x56,
0x86,0x20,0x5d,0x0c,0xad,0x08,0xd6,0x80,0xa2,0x16,0x80,0x82,0x16,0x8e,0xb4,0x0c,
0x42,0xd1,0xaf,0xf7,0xd7,0x7d,0x7f,0xfb,0xff,0xed,0xfb,0x00,0x00,0x00,0x00,0xca,
0x96,0x89,0xe4,0x02,0xe0,0x88,0x91,0x83,0x16,0x39,0xd2,0xc2,0xa5,0xc3,0xf2,0xb4,
0x2b,0x10,0xc7,0xc6,0x34,0x98,0xf9,0xa8,0x7a,0x3c,0xd4,0xc9,0xbd,0x33,0xef,0x4d,
0x77,0x9b,0x97,0x06,0xd8,0xaa,0x08,0x88,0x3f,0x9f,0x3e,0xf9,0xf3,0xef,0x4b,0x6e,
0x7d,0xf3,0xe1,0x77,0xcb,0x84,0x40,0xfa,0x34,0x62,0x45,0x2a,0x59,0x58,0x44,0x0e,
0xe3,0x48,0x44,0x0e,0xd1,0xa2,0xa9,0x05,0xe9,0x42,0x68,0xa4,0x0d,0x4c,0x69,0x46,
0x20,0x74,0xc4,0x4a,0x64,0x0f,0x71,0xa2,0xb1,0xa9,0x52,0x62,0x95,0x88,0x1d,0x34,
0x94,0xcc,0x1d,0x00,0x02,0xa5,0x3a,0x01,0x16,0x91,0xa2,0x39,0xdb,0x70,0x77,0x41,
0x08,0xc0,0x5a,0x16,0x24,0xc3,0x8e,0xe4,0xfd,0x39,0x79,0xbb,0xab,0xfb,0xe0,0xf1,
0xe0,0xb1,0xa9,0xbb,0x52,0x8d,0x4c,0x77,0xd6,0x44,0xed,0x64,0x8e,0x39,0x45,0x1a,
0xf5,0x16,0x26,0xfa,0xd2,0xce,0xea,0x90,0xc7,0xc7,0x24,0x52,0x92,0x67,0xea,0x43,
0x0d,0x8a,0x01,0x18,0x31,0x65,0xc9,0x9f,0x8d,0x22,0x3c,0xd0,0xa1,0x86,0x3a,0xb4,
0xd4,0x96,0xbe,0xb4,0x0b,0x1a,0x6b,0xa8,0x00,0x00,0x0d,0x8f,0x60,0x01,0x34,0x3d,
0x0d,0x6c,0x9f,0xbe,0x45,0x8d,0x2e,0xa9,0xdc,0x21,0x4d,0x17,0xaa,0x5d,0xa3,0x71,
0xf1,0xb8,0xb4,0x63,0xc5,0x68,0xf3,0x64,0xa3,0x49,0x57,0xab,0x4d,0xbd,0x7c,0x7c,
0x1f,0x97,0x3c,0xbb,0x38,0x5a,0x79,0xf7,0xdb,0xa4,0x6b,0x61,0x9d,0x7d,0x38,0x5a,
0x71,0x7c,0x88,0x14,0xc6,0x20,0x77,0x1e,0x03,0xc9,0xac,0x33,0x57,0xdc,0xe1,0x61,
0x36,0x13,0x41,0x11,0x34,0xa3,0x10,0x69,0x8e,0x60,0xe9,0x0b,0x94,0x9c,0x9d,0xab,
0xe3,0x90,0x29,0x8c,0xa0,0xb3,0x14,0xad,0x09,0x26,0x6f,0x38,0xf3,0x88,0x01,0xe1,
0xe1,0xf1,0xe4,0x49,0xd9,0x0a,0xe3,0x22,0xe7,0x5b,0x36,0xff,0xfb,0x92,0x00,0x06,
0x80,0x02,0xd2,0x1f,0x5d,0x0b,0x26,0x12,0x50,0x5b,0x23,0xeb,0xa1,0x65,0x22,0x4a,
0x0c,0x78,0x4b,0x77,0x2c,0x18,0x67,0x29,0x83,0x8e,0x6d,0xc5,0x84,0x8d,0x28,0x03,
0xaa,0x81,0xd8,0x09,0x5c,0x6e,0xc8,0xc7,0x03,0xfc,0x97,0xe1,0xe1,0x1d,0x52,0x09,
0xa3,0xd0,0x78,0x3c,0x4e,0xd3,0xd5,0x25,0x78,0xce,0x5a,0x1a,0xe5,0x17,0x20,0x7a,
0xa4,0x9d,0xad,0x0e,0x7a,0xd6,0xd7,0x4a,0xb0,0xfe,0x4c,0x51,0xea,0x43,0x6b,0x28,
0x87,0x35,0x69,0x7d,0x49,0x71,0xba,0x85,0xdd,0x2c,0xc7,0xdc,0x81,0x4a,0x92,0xd8,
0xb2,0x2e,0x6a,0xc8,0xbe,0xaf,0xb1,0xdb,0x7f,0xa7,0xfe,0xef,0xc0,0x78,0x78,0x8c,
0x79,0x12,0x76,0x42,0xb8,0xc8,0xb9,0x9b,0x9b,0x84,0x67,0xa4,0x47,0x41,0xe7,0x72,
0x5d,0x88,0xe5,0x97,0xce,0xb7,0xb7,0xc4,0x3a,0x92,0x09,0xa2,0xa8,0x3c,0x3d,0x0b,
0x46,0x9e,0xa4,0x83,0xc4,0xb9,0x65,0x03,0xd5,0x2c,0x8b,0xaa,0x24,0x7d,0xcb,0x4b,
0x1f,0x43,0x6b,0x4a,0x0f,0x56,0x97,0xb9,0x4a,0x38,0x6e,0x55,0xae,0xa1,0x82,0xee,
0x1c,0x86,0x54,0x9b,0xc5,0x94,0x97,0x56,0xd7,0x98,0xa0,0x59,0xf4,0xb3,0x32,0x9d,
0x68,0xd5,0xbf,0x63,0xff,0x47,0xfd,0xf8,0xa0,0x00,0x00,0x08,0xb9,0xa2,0x63,0xa4,
0x9f,0x65,0x50,0x7e,0xda,0xcd,0x14,0x9b,0xc1,0x54,0xc4,0xb6,0x9d,0x89,0x6b,0xae,
0xb2,0x2f,0xb6,0xdd,0x13,0x9a,0x6b,0xb2,0x38,0x53,0xf1,0x34,0x6b,0xbb,0xd9,0x5e,
0xcd,0x31,0x1a,0x6a,0xa8,0x4c,0xb2,0x4a,0x2b,0x05,0x8a,0xc2,0x70,0x2c,0x18,0xaa,
0x83,0x4d,0x8a,0xc1,0x52,0xe4,0x94,0x17,0x58,0xa2,0x0a,0xd8,0x50,0x48,0x2f,0xa5,
0x06,0x0a,0xb8,0x29,0x53,0x6c,0x14,0x58,0xeb,0x82,0x92,0x1b,0x30,0x55,0x43,0x82,
0xc1,0x69,0x14,0x31,0x27,0x46,0xa3,0x46,0xc8,0xa4,0xad,0x00,0xe6,0x04,0xa4,0xb4,
0x2d,0x1e,0x9b,0x3e,0xd7,0x2c,0x9a,0xac,0xa7,0x00,0x29,0xea,0x0b,0x6a,0x29,0xd0,
0x59,0xfd,0x0e,0x21,0x82,0x48,0x73,0x25,0x00,0xba,0x03,0x9a,0xd0,0x1e,0x0a,0xd7,
0x82,0xba,0xb5,0x4a,0x89,0x8e,0x2c,0x1a,0x8d,0x2a,0x41,0x8e,0x59,0x22,0x27,0x54,
0x44,0x81,0xe5,0xc9,0x1d,0x54,0x4a,0xe7,0x4a,0xb8,0xec,0xb3,0xcf,0x4a,0xb8,0xf4,
0xb0,0x14,0x3b,0x2a,0x02,0x0d,0x4b,0x16,0x0e,0xde,0x54,0x8b,0x5e,0xb6,0x31,0xcb,
0x69,0x17,0xa9,0x84,0x9c,0xb8,0x95,0xef,0x6a,0x7a,0x6f,0xee,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

	}//Sound
}//FDK